#pragma once

public ref class CBMD
{
public:
	CBMD(CNitroFile^ file);
	~CBMD();

	//

	value struct SVertex
	{
		Vector3 m_Position;
		UInt32 m_Color;
		Vector2 m_Texcoord;
	};

	ref class CGeometryBlock
	{
	public:
		CGeometryBlock() {}
		~CGeometryBlock() 
		{
			delete m_VertexList;
		}

		UInt32 m_Type;
		List<SVertex>^ m_VertexList;
	};

	ref class CMatPolyPair
	{
	public:
		CMatPolyPair() {}
		~CMatPolyPair() 
		{
			delete m_Texture;
			for each (CGeometryBlock^ gblock in m_Geometry)
				delete gblock;
		}

		bool IsTranslucent()
		{
			return ((m_PolyAttributes & 0x001F0000) != 0x001F0000) ||
					((m_TexParams & 0x1C000000) == 0x04000000) ||
					((m_TexParams & 0x1C000000) == 0x18000000);
		}

		UInt32 m_ID;
		String^ m_Name;

		UInt32 m_PolyAttributes;
		UInt32 m_DifAmbColors;
		UInt32 m_SpeEmiColors;
		UInt32 m_TexParams;

		UInt32 m_TexWidth, m_TexHeight;
		array<Byte>^ m_Texture; // nullptr = no texture :)
		String^ m_TexName;
		List<CGeometryBlock^>^ m_Geometry;
	};

	ref class CModelChunk
	{
	public:
		CModelChunk() {}
		~CModelChunk() 
		{
			for each (CMatPolyPair^ mppair in m_MatPolyPairs)
				delete mppair;
		}

		UInt32 m_ID;
		String^ m_Name;

		array<CMatPolyPair^>^ m_MatPolyPairs;
	};

	array<CModelChunk^>^ m_ModelChunks;

	UInt32 m_ScaleFactor;

private:
	CNitroFile^ m_File;

	UInt32 m_NumModelChunks;
	UInt32 m_ModelChunksOffset;
	UInt32 m_NumPolyChunks;
	UInt32 m_PolyChunksOffset;
	UInt32 m_NumTexChunks;
	UInt32 m_TexChunksOffset;
	UInt32 m_NumPalChunks;
	UInt32 m_PalChunksOffset;
	UInt32 m_NumMatChunks;
	UInt32 m_MatChunksOffset;

	void ReadTexture(CMatPolyPair^ mppair, UInt32 texid, UInt32 palid);
	void ProcessGXCommand(CMatPolyPair^ mppair, Byte cmd, UInt32% pos);

	SVertex m_CurVertex;
};
