#pragma once

using namespace System;
using namespace System::ComponentModel;
using namespace System::Collections;
using namespace System::Collections::Generic;
using namespace System::Windows::Forms;
using namespace System::Data;
using namespace System::Drawing;
using namespace System::Globalization;
using namespace OpenTK;
using namespace OpenTK::Graphics;
using namespace OpenTK::Graphics::OpenGL;

#include "NitroROM.h"
#include "NitroFile.h"
#include "NitroOverlay.h"

#include "leveldata.h"
#include "levelclasses.h"

#include "LevelSettingsForm.h"

#include "BMD.h"
#include "3dstuff.h"


#define OBJLISTS array<TPosObjList^>^ objlists = {m_StdObjects, m_SimpleObjects, m_ExtraObjects};


namespace sm64ds_editor
{
	/// <summary>
	/// Description rsume de EditorMainForm
	///
	/// AVERTISSEMENT: si vous modifiez le nom de cette classe, vous devrez modifier la
	///          proprit 'Nom du fichier de ressources' de l'outil de compilation de ressource manage
	///          pour tous les fichiers .resx dont dpend cette classe. Dans le cas contraire,
	///          les concepteurs ne pourront pas interagir correctement avec les ressources
	///          localises associes  ce formulaire.
	/// </summary>
	public ref class EditorMainForm : public System::Windows::Forms::Form
	{
	public:
		EditorMainForm(List<EditorMainForm^>^ editorlist, CNitroROM^ rom, int levelid)
		{
			m_MouseDown = 0;
			m_GLLoaded = false;

			InitializeComponent();

			m_EditorList = editorlist;
			m_ROM = rom;
			m_LevelID = levelid;
			
			LoadLevelData();

			sblStatusLabel->Text = "Ready";
			m_CurObjType = 0;
			m_SelObjType = -1;
		}

	protected:
		/// <summary>
		/// Nettoyage des ressources utilises.
		/// </summary>
		~EditorMainForm()
		{
			DeleteLevelData();

			m_EditorList->Remove(this);

			if (components)
			{
				delete components;
			}

			//for each (Control^ ctl in tlpObjEditPanel->Controls)
			//	delete ctl;

			//delete toolStrip1; delete btnSaveLevel; delete toolStripSeparator1; delete btnLevelSettings;
			//delete toolStripSeparator2; delete toolStripLabel1; delete glc3DView; delete tvModelBlocks;
		}

	private: System::Windows::Forms::ToolStrip^  toolStrip1;
	private: System::Windows::Forms::ToolStripButton^  btnSaveLevel;

	private: System::Windows::Forms::ToolStripButton^  btnLevelSettings;


	private: OpenTK::GLControl^  glc3DView;
	private: System::Windows::Forms::TreeView^  tvModelBlocks;
	private: System::Windows::Forms::SplitContainer^  splitContainer1;
	private: System::Windows::Forms::TabControl^  tbcLeftPanel;
	private: System::Windows::Forms::TabPage^  tbpModelBlox;
	private: System::Windows::Forms::TabPage^  tbpObjects;
	private: System::Windows::Forms::TabControl^  tbcObjTypeTabs;
	private: System::Windows::Forms::TabPage^  tbpObj0Panel;
	private: System::Windows::Forms::TabPage^  tbpObj1Panel;

	private: System::Windows::Forms::SplitContainer^  scObjPanelContainer;
	private: System::Windows::Forms::StatusStrip^  sbrStatus;
	private: System::Windows::Forms::ToolStripStatusLabel^  sblStatusLabel;
	private: System::Windows::Forms::TableLayoutPanel^  tlpObjEditPanel;
	private: System::Windows::Forms::ToolStripButton^  btnLayer0;
	private: System::Windows::Forms::ToolStripButton^  btnLayer1;
	private: System::Windows::Forms::ToolStripButton^  btnLayer2;
	private: System::Windows::Forms::ToolStripButton^  btnLayer3;
	private: System::Windows::Forms::ToolStripButton^  btnLayer4;
	private: System::Windows::Forms::ToolStripButton^  btnLayer5;
	private: System::Windows::Forms::ToolStripButton^  btnLayer6;
	private: System::Windows::Forms::ToolStripButton^  btnLayer7;
	private: System::Windows::Forms::ToolStrip^  toolStrip2;




	private: System::Windows::Forms::TreeView^  tvObjectList;
	private: System::Windows::Forms::ToolStripSplitButton^  btnAddObject;



	private: System::Windows::Forms::TabPage^  tbpObj2Panel;
	private: System::Windows::Forms::ToolStripMenuItem^  btnAddObj0;
	private: System::Windows::Forms::ToolStripMenuItem^  btnAddObj1;
	private: System::Windows::Forms::ToolStripMenuItem^  btnAddObj2;
	private: System::Windows::Forms::ToolStripMenuItem^  btnAddObj3;
	private: System::Windows::Forms::ToolStripMenuItem^  btnAddObj4;
	private: System::Windows::Forms::ToolStripMenuItem^  btnAddObj5;
	private: System::Windows::Forms::ToolStripMenuItem^  btnAddObj6;

	private: System::Windows::Forms::ToolStripButton^  btnRemoveObject;
	private: System::Windows::Forms::ToolStripMenuItem^  btnAddObj7;
	private: System::Windows::Forms::ContextMenuStrip^  ctm3DOptions;
	private: System::Windows::Forms::ToolStripMenuItem^  btnDumpTexture;
	private: System::Windows::Forms::SaveFileDialog^  texexport;
	private: System::Windows::Forms::ToolStripButton^  btnReverseRot;
	private: System::ComponentModel::IContainer^  components;

	protected: 


	private:
		/// <summary>
		/// Variable ncessaire au concepteur.
		/// </summary>


#pragma region Windows Form Designer generated code
		/// <summary>
		/// Mthode requise pour la prise en charge du concepteur - ne modifiez pas
		/// le contenu de cette mthode avec l'diteur de code.
		/// </summary>
		void InitializeComponent(void)
		{
			this->components = (gcnew System::ComponentModel::Container());
			System::Windows::Forms::ToolStripSeparator^  toolStripSeparator1;
			System::Windows::Forms::ToolStripSeparator^  toolStripSeparator2;
			System::Windows::Forms::ToolStripLabel^  toolStripLabel1;
			System::ComponentModel::ComponentResourceManager^  resources = (gcnew System::ComponentModel::ComponentResourceManager(EditorMainForm::typeid));
			System::Windows::Forms::TreeNode^  treeNode1 = (gcnew System::Windows::Forms::TreeNode(L"Common"));
			System::Windows::Forms::TreeNode^  treeNode2 = (gcnew System::Windows::Forms::TreeNode(L"Layer blahblah"));
			this->toolStrip1 = (gcnew System::Windows::Forms::ToolStrip());
			this->btnSaveLevel = (gcnew System::Windows::Forms::ToolStripButton());
			this->btnLevelSettings = (gcnew System::Windows::Forms::ToolStripButton());
			this->btnLayer0 = (gcnew System::Windows::Forms::ToolStripButton());
			this->btnLayer1 = (gcnew System::Windows::Forms::ToolStripButton());
			this->btnLayer2 = (gcnew System::Windows::Forms::ToolStripButton());
			this->btnLayer3 = (gcnew System::Windows::Forms::ToolStripButton());
			this->btnLayer4 = (gcnew System::Windows::Forms::ToolStripButton());
			this->btnLayer5 = (gcnew System::Windows::Forms::ToolStripButton());
			this->btnLayer6 = (gcnew System::Windows::Forms::ToolStripButton());
			this->btnLayer7 = (gcnew System::Windows::Forms::ToolStripButton());
			this->glc3DView = (gcnew OpenTK::GLControl());
			this->tvModelBlocks = (gcnew System::Windows::Forms::TreeView());
			this->ctm3DOptions = (gcnew System::Windows::Forms::ContextMenuStrip(this->components));
			this->btnDumpTexture = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->splitContainer1 = (gcnew System::Windows::Forms::SplitContainer());
			this->tbcLeftPanel = (gcnew System::Windows::Forms::TabControl());
			this->tbpModelBlox = (gcnew System::Windows::Forms::TabPage());
			this->tbpObjects = (gcnew System::Windows::Forms::TabPage());
			this->scObjPanelContainer = (gcnew System::Windows::Forms::SplitContainer());
			this->tbcObjTypeTabs = (gcnew System::Windows::Forms::TabControl());
			this->tbpObj0Panel = (gcnew System::Windows::Forms::TabPage());
			this->tvObjectList = (gcnew System::Windows::Forms::TreeView());
			this->tbpObj1Panel = (gcnew System::Windows::Forms::TabPage());
			this->tbpObj2Panel = (gcnew System::Windows::Forms::TabPage());
			this->tlpObjEditPanel = (gcnew System::Windows::Forms::TableLayoutPanel());
			this->toolStrip2 = (gcnew System::Windows::Forms::ToolStrip());
			this->btnAddObject = (gcnew System::Windows::Forms::ToolStripSplitButton());
			this->btnAddObj0 = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->btnAddObj1 = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->btnAddObj2 = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->btnAddObj3 = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->btnAddObj4 = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->btnAddObj5 = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->btnAddObj6 = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->btnAddObj7 = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->btnRemoveObject = (gcnew System::Windows::Forms::ToolStripButton());
			this->btnReverseRot = (gcnew System::Windows::Forms::ToolStripButton());
			this->sbrStatus = (gcnew System::Windows::Forms::StatusStrip());
			this->sblStatusLabel = (gcnew System::Windows::Forms::ToolStripStatusLabel());
			this->texexport = (gcnew System::Windows::Forms::SaveFileDialog());
			toolStripSeparator1 = (gcnew System::Windows::Forms::ToolStripSeparator());
			toolStripSeparator2 = (gcnew System::Windows::Forms::ToolStripSeparator());
			toolStripLabel1 = (gcnew System::Windows::Forms::ToolStripLabel());
			this->toolStrip1->SuspendLayout();
			this->ctm3DOptions->SuspendLayout();
			this->splitContainer1->Panel1->SuspendLayout();
			this->splitContainer1->Panel2->SuspendLayout();
			this->splitContainer1->SuspendLayout();
			this->tbcLeftPanel->SuspendLayout();
			this->tbpModelBlox->SuspendLayout();
			this->tbpObjects->SuspendLayout();
			this->scObjPanelContainer->Panel1->SuspendLayout();
			this->scObjPanelContainer->Panel2->SuspendLayout();
			this->scObjPanelContainer->SuspendLayout();
			this->tbcObjTypeTabs->SuspendLayout();
			this->tbpObj0Panel->SuspendLayout();
			this->toolStrip2->SuspendLayout();
			this->sbrStatus->SuspendLayout();
			this->SuspendLayout();
			// 
			// toolStripSeparator1
			// 
			toolStripSeparator1->Name = L"toolStripSeparator1";
			toolStripSeparator1->Size = System::Drawing::Size(6, 25);
			// 
			// toolStripSeparator2
			// 
			toolStripSeparator2->Name = L"toolStripSeparator2";
			toolStripSeparator2->Size = System::Drawing::Size(6, 25);
			// 
			// toolStripLabel1
			// 
			toolStripLabel1->Name = L"toolStripLabel1";
			toolStripLabel1->Size = System::Drawing::Size(125, 22);
			toolStripLabel1->Text = L"Show objects for stars:";
			// 
			// toolStrip1
			// 
			this->toolStrip1->Items->AddRange(gcnew cli::array< System::Windows::Forms::ToolStripItem^  >(13) {this->btnSaveLevel, toolStripSeparator1, 
				this->btnLevelSettings, toolStripSeparator2, toolStripLabel1, this->btnLayer0, this->btnLayer1, this->btnLayer2, this->btnLayer3, 
				this->btnLayer4, this->btnLayer5, this->btnLayer6, this->btnLayer7});
			this->toolStrip1->Location = System::Drawing::Point(0, 0);
			this->toolStrip1->Name = L"toolStrip1";
			this->toolStrip1->Size = System::Drawing::Size(963, 25);
			this->toolStrip1->TabIndex = 0;
			this->toolStrip1->Text = L"toolStrip1";
			// 
			// btnSaveLevel
			// 
			this->btnSaveLevel->DisplayStyle = System::Windows::Forms::ToolStripItemDisplayStyle::Text;
			this->btnSaveLevel->Image = (cli::safe_cast<System::Drawing::Image^  >(resources->GetObject(L"btnSaveLevel.Image")));
			this->btnSaveLevel->ImageTransparentColor = System::Drawing::Color::Magenta;
			this->btnSaveLevel->Name = L"btnSaveLevel";
			this->btnSaveLevel->Size = System::Drawing::Size(35, 22);
			this->btnSaveLevel->Text = L"Save";
			this->btnSaveLevel->ToolTipText = L"don\'t forget to click\r\nme regularly if you\r\ndon\'t want to lose\r\nyour changes";
			this->btnSaveLevel->Click += gcnew System::EventHandler(this, &EditorMainForm::btnSaveLevel_Click);
			// 
			// btnLevelSettings
			// 
			this->btnLevelSettings->DisplayStyle = System::Windows::Forms::ToolStripItemDisplayStyle::Text;
			this->btnLevelSettings->Image = (cli::safe_cast<System::Drawing::Image^  >(resources->GetObject(L"btnLevelSettings.Image")));
			this->btnLevelSettings->ImageTransparentColor = System::Drawing::Color::Magenta;
			this->btnLevelSettings->Name = L"btnLevelSettings";
			this->btnLevelSettings->Size = System::Drawing::Size(82, 22);
			this->btnLevelSettings->Text = L"Level settings";
			this->btnLevelSettings->ToolTipText = L"change the sky and all that";
			this->btnLevelSettings->Click += gcnew System::EventHandler(this, &EditorMainForm::btnLevelSettings_Click);
			// 
			// btnLayer0
			// 
			this->btnLayer0->CheckOnClick = true;
			this->btnLayer0->DisplayStyle = System::Windows::Forms::ToolStripItemDisplayStyle::Text;
			this->btnLayer0->Image = (cli::safe_cast<System::Drawing::Image^  >(resources->GetObject(L"btnLayer0.Image")));
			this->btnLayer0->ImageTransparentColor = System::Drawing::Color::Magenta;
			this->btnLayer0->Name = L"btnLayer0";
			this->btnLayer0->Size = System::Drawing::Size(25, 22);
			this->btnLayer0->Tag = L"0";
			this->btnLayer0->Text = L"All";
			this->btnLayer0->Click += gcnew System::EventHandler(this, &EditorMainForm::btnLayer0_Click);
			// 
			// btnLayer1
			// 
			this->btnLayer1->CheckOnClick = true;
			this->btnLayer1->DisplayStyle = System::Windows::Forms::ToolStripItemDisplayStyle::Text;
			this->btnLayer1->Image = (cli::safe_cast<System::Drawing::Image^  >(resources->GetObject(L"btnLayer1.Image")));
			this->btnLayer1->ImageTransparentColor = System::Drawing::Color::Magenta;
			this->btnLayer1->Name = L"btnLayer1";
			this->btnLayer1->Size = System::Drawing::Size(23, 22);
			this->btnLayer1->Tag = L"1";
			this->btnLayer1->Text = L"1";
			this->btnLayer1->Click += gcnew System::EventHandler(this, &EditorMainForm::btnLayerN_Click);
			// 
			// btnLayer2
			// 
			this->btnLayer2->CheckOnClick = true;
			this->btnLayer2->DisplayStyle = System::Windows::Forms::ToolStripItemDisplayStyle::Text;
			this->btnLayer2->Image = (cli::safe_cast<System::Drawing::Image^  >(resources->GetObject(L"btnLayer2.Image")));
			this->btnLayer2->ImageTransparentColor = System::Drawing::Color::Magenta;
			this->btnLayer2->Name = L"btnLayer2";
			this->btnLayer2->Size = System::Drawing::Size(23, 22);
			this->btnLayer2->Tag = L"2";
			this->btnLayer2->Text = L"2";
			this->btnLayer2->Click += gcnew System::EventHandler(this, &EditorMainForm::btnLayerN_Click);
			// 
			// btnLayer3
			// 
			this->btnLayer3->CheckOnClick = true;
			this->btnLayer3->DisplayStyle = System::Windows::Forms::ToolStripItemDisplayStyle::Text;
			this->btnLayer3->Image = (cli::safe_cast<System::Drawing::Image^  >(resources->GetObject(L"btnLayer3.Image")));
			this->btnLayer3->ImageTransparentColor = System::Drawing::Color::Magenta;
			this->btnLayer3->Name = L"btnLayer3";
			this->btnLayer3->Size = System::Drawing::Size(23, 22);
			this->btnLayer3->Tag = L"3";
			this->btnLayer3->Text = L"3";
			this->btnLayer3->Click += gcnew System::EventHandler(this, &EditorMainForm::btnLayerN_Click);
			// 
			// btnLayer4
			// 
			this->btnLayer4->CheckOnClick = true;
			this->btnLayer4->DisplayStyle = System::Windows::Forms::ToolStripItemDisplayStyle::Text;
			this->btnLayer4->Image = (cli::safe_cast<System::Drawing::Image^  >(resources->GetObject(L"btnLayer4.Image")));
			this->btnLayer4->ImageTransparentColor = System::Drawing::Color::Magenta;
			this->btnLayer4->Name = L"btnLayer4";
			this->btnLayer4->Size = System::Drawing::Size(23, 22);
			this->btnLayer4->Tag = L"4";
			this->btnLayer4->Text = L"4";
			this->btnLayer4->Click += gcnew System::EventHandler(this, &EditorMainForm::btnLayerN_Click);
			// 
			// btnLayer5
			// 
			this->btnLayer5->CheckOnClick = true;
			this->btnLayer5->DisplayStyle = System::Windows::Forms::ToolStripItemDisplayStyle::Text;
			this->btnLayer5->Image = (cli::safe_cast<System::Drawing::Image^  >(resources->GetObject(L"btnLayer5.Image")));
			this->btnLayer5->ImageTransparentColor = System::Drawing::Color::Magenta;
			this->btnLayer5->Name = L"btnLayer5";
			this->btnLayer5->Size = System::Drawing::Size(23, 22);
			this->btnLayer5->Tag = L"5";
			this->btnLayer5->Text = L"5";
			this->btnLayer5->Click += gcnew System::EventHandler(this, &EditorMainForm::btnLayerN_Click);
			// 
			// btnLayer6
			// 
			this->btnLayer6->CheckOnClick = true;
			this->btnLayer6->DisplayStyle = System::Windows::Forms::ToolStripItemDisplayStyle::Text;
			this->btnLayer6->Image = (cli::safe_cast<System::Drawing::Image^  >(resources->GetObject(L"btnLayer6.Image")));
			this->btnLayer6->ImageTransparentColor = System::Drawing::Color::Magenta;
			this->btnLayer6->Name = L"btnLayer6";
			this->btnLayer6->Size = System::Drawing::Size(23, 22);
			this->btnLayer6->Tag = L"6";
			this->btnLayer6->Text = L"6";
			this->btnLayer6->Click += gcnew System::EventHandler(this, &EditorMainForm::btnLayerN_Click);
			// 
			// btnLayer7
			// 
			this->btnLayer7->CheckOnClick = true;
			this->btnLayer7->DisplayStyle = System::Windows::Forms::ToolStripItemDisplayStyle::Text;
			this->btnLayer7->Image = (cli::safe_cast<System::Drawing::Image^  >(resources->GetObject(L"btnLayer7.Image")));
			this->btnLayer7->ImageTransparentColor = System::Drawing::Color::Magenta;
			this->btnLayer7->Name = L"btnLayer7";
			this->btnLayer7->Size = System::Drawing::Size(23, 22);
			this->btnLayer7->Tag = L"7";
			this->btnLayer7->Text = L"7";
			this->btnLayer7->Click += gcnew System::EventHandler(this, &EditorMainForm::btnLayerN_Click);
			// 
			// glc3DView
			// 
			this->glc3DView->Anchor = static_cast<System::Windows::Forms::AnchorStyles>((((System::Windows::Forms::AnchorStyles::Top | System::Windows::Forms::AnchorStyles::Bottom) 
				| System::Windows::Forms::AnchorStyles::Left) 
				| System::Windows::Forms::AnchorStyles::Right));
			this->glc3DView->BackColor = System::Drawing::Color::Black;
			this->glc3DView->Location = System::Drawing::Point(0, 28);
			this->glc3DView->Name = L"glc3DView";
			this->glc3DView->Size = System::Drawing::Size(719, 535);
			this->glc3DView->TabIndex = 3;
			this->glc3DView->VSync = false;
			this->glc3DView->Load += gcnew System::EventHandler(this, &EditorMainForm::glc3DView_Load);
			this->glc3DView->MouseWheel += gcnew System::Windows::Forms::MouseEventHandler(this, &EditorMainForm::glc3DView_MouseWheel);
			this->glc3DView->Paint += gcnew System::Windows::Forms::PaintEventHandler(this, &EditorMainForm::glc3DView_Paint);
			this->glc3DView->MouseMove += gcnew System::Windows::Forms::MouseEventHandler(this, &EditorMainForm::glc3DView_MouseMove);
			this->glc3DView->MouseDown += gcnew System::Windows::Forms::MouseEventHandler(this, &EditorMainForm::glc3DView_MouseDown);
			this->glc3DView->Resize += gcnew System::EventHandler(this, &EditorMainForm::glc3DView_Resize);
			this->glc3DView->MouseUp += gcnew System::Windows::Forms::MouseEventHandler(this, &EditorMainForm::glc3DView_MouseUp);
			this->glc3DView->KeyDown += gcnew System::Windows::Forms::KeyEventHandler(this, &EditorMainForm::glc3DView_KeyDown);
			// 
			// tvModelBlocks
			// 
			this->tvModelBlocks->CheckBoxes = true;
			this->tvModelBlocks->Dock = System::Windows::Forms::DockStyle::Fill;
			this->tvModelBlocks->Location = System::Drawing::Point(0, 0);
			this->tvModelBlocks->Margin = System::Windows::Forms::Padding(0);
			this->tvModelBlocks->Name = L"tvModelBlocks";
			this->tvModelBlocks->Size = System::Drawing::Size(232, 537);
			this->tvModelBlocks->TabIndex = 5;
			this->tvModelBlocks->AfterCheck += gcnew System::Windows::Forms::TreeViewEventHandler(this, &EditorMainForm::tvModelBlocks_AfterCheck);
			this->tvModelBlocks->MouseClick += gcnew System::Windows::Forms::MouseEventHandler(this, &EditorMainForm::tvModelBlocks_MouseClick);
			// 
			// ctm3DOptions
			// 
			this->ctm3DOptions->Items->AddRange(gcnew cli::array< System::Windows::Forms::ToolStripItem^  >(1) {this->btnDumpTexture});
			this->ctm3DOptions->Name = L"ctm3DOptions";
			this->ctm3DOptions->Size = System::Drawing::Size(147, 26);
			// 
			// btnDumpTexture
			// 
			this->btnDumpTexture->Name = L"btnDumpTexture";
			this->btnDumpTexture->Size = System::Drawing::Size(146, 22);
			this->btnDumpTexture->Text = L"Dump texture";
			this->btnDumpTexture->Click += gcnew System::EventHandler(this, &EditorMainForm::btnDumpTexture_Click);
			// 
			// splitContainer1
			// 
			this->splitContainer1->Anchor = static_cast<System::Windows::Forms::AnchorStyles>((((System::Windows::Forms::AnchorStyles::Top | System::Windows::Forms::AnchorStyles::Bottom) 
				| System::Windows::Forms::AnchorStyles::Left) 
				| System::Windows::Forms::AnchorStyles::Right));
			this->splitContainer1->FixedPanel = System::Windows::Forms::FixedPanel::Panel1;
			this->splitContainer1->Location = System::Drawing::Point(0, 25);
			this->splitContainer1->Margin = System::Windows::Forms::Padding(0);
			this->splitContainer1->Name = L"splitContainer1";
			// 
			// splitContainer1.Panel1
			// 
			this->splitContainer1->Panel1->Controls->Add(this->tbcLeftPanel);
			// 
			// splitContainer1.Panel2
			// 
			this->splitContainer1->Panel2->Controls->Add(this->toolStrip2);
			this->splitContainer1->Panel2->Controls->Add(this->glc3DView);
			this->splitContainer1->Size = System::Drawing::Size(963, 563);
			this->splitContainer1->SplitterDistance = 240;
			this->splitContainer1->TabIndex = 6;
			// 
			// tbcLeftPanel
			// 
			this->tbcLeftPanel->Alignment = System::Windows::Forms::TabAlignment::Bottom;
			this->tbcLeftPanel->Controls->Add(this->tbpModelBlox);
			this->tbcLeftPanel->Controls->Add(this->tbpObjects);
			this->tbcLeftPanel->Dock = System::Windows::Forms::DockStyle::Fill;
			this->tbcLeftPanel->Location = System::Drawing::Point(0, 0);
			this->tbcLeftPanel->Margin = System::Windows::Forms::Padding(0);
			this->tbcLeftPanel->Multiline = true;
			this->tbcLeftPanel->Name = L"tbcLeftPanel";
			this->tbcLeftPanel->SelectedIndex = 0;
			this->tbcLeftPanel->Size = System::Drawing::Size(240, 563);
			this->tbcLeftPanel->TabIndex = 0;
			this->tbcLeftPanel->SelectedIndexChanged += gcnew System::EventHandler(this, &EditorMainForm::tbcLeftPanel_SelectedIndexChanged);
			// 
			// tbpModelBlox
			// 
			this->tbpModelBlox->Controls->Add(this->tvModelBlocks);
			this->tbpModelBlox->Location = System::Drawing::Point(4, 4);
			this->tbpModelBlox->Margin = System::Windows::Forms::Padding(0);
			this->tbpModelBlox->Name = L"tbpModelBlox";
			this->tbpModelBlox->Size = System::Drawing::Size(232, 537);
			this->tbpModelBlox->TabIndex = 0;
			this->tbpModelBlox->Text = L"3D model";
			this->tbpModelBlox->UseVisualStyleBackColor = true;
			// 
			// tbpObjects
			// 
			this->tbpObjects->Controls->Add(this->scObjPanelContainer);
			this->tbpObjects->Location = System::Drawing::Point(4, 4);
			this->tbpObjects->Margin = System::Windows::Forms::Padding(0);
			this->tbpObjects->Name = L"tbpObjects";
			this->tbpObjects->Size = System::Drawing::Size(232, 537);
			this->tbpObjects->TabIndex = 1;
			this->tbpObjects->Text = L"Objects";
			this->tbpObjects->UseVisualStyleBackColor = true;
			// 
			// scObjPanelContainer
			// 
			this->scObjPanelContainer->Dock = System::Windows::Forms::DockStyle::Fill;
			this->scObjPanelContainer->FixedPanel = System::Windows::Forms::FixedPanel::Panel2;
			this->scObjPanelContainer->Location = System::Drawing::Point(0, 0);
			this->scObjPanelContainer->Margin = System::Windows::Forms::Padding(0);
			this->scObjPanelContainer->Name = L"scObjPanelContainer";
			this->scObjPanelContainer->Orientation = System::Windows::Forms::Orientation::Horizontal;
			// 
			// scObjPanelContainer.Panel1
			// 
			this->scObjPanelContainer->Panel1->Controls->Add(this->tbcObjTypeTabs);
			// 
			// scObjPanelContainer.Panel2
			// 
			this->scObjPanelContainer->Panel2->Controls->Add(this->tlpObjEditPanel);
			this->scObjPanelContainer->Size = System::Drawing::Size(232, 537);
			this->scObjPanelContainer->SplitterDistance = 242;
			this->scObjPanelContainer->TabIndex = 3;
			// 
			// tbcObjTypeTabs
			// 
			this->tbcObjTypeTabs->Controls->Add(this->tbpObj0Panel);
			this->tbcObjTypeTabs->Controls->Add(this->tbpObj1Panel);
			this->tbcObjTypeTabs->Controls->Add(this->tbpObj2Panel);
			this->tbcObjTypeTabs->Dock = System::Windows::Forms::DockStyle::Fill;
			this->tbcObjTypeTabs->Location = System::Drawing::Point(0, 0);
			this->tbcObjTypeTabs->Margin = System::Windows::Forms::Padding(0);
			this->tbcObjTypeTabs->Name = L"tbcObjTypeTabs";
			this->tbcObjTypeTabs->SelectedIndex = 0;
			this->tbcObjTypeTabs->Size = System::Drawing::Size(232, 242);
			this->tbcObjTypeTabs->TabIndex = 2;
			this->tbcObjTypeTabs->SelectedIndexChanged += gcnew System::EventHandler(this, &EditorMainForm::tbcObjTypeTabs_SelectedIndexChanged);
			// 
			// tbpObj0Panel
			// 
			this->tbpObj0Panel->Controls->Add(this->tvObjectList);
			this->tbpObj0Panel->Location = System::Drawing::Point(4, 22);
			this->tbpObj0Panel->Margin = System::Windows::Forms::Padding(0);
			this->tbpObj0Panel->Name = L"tbpObj0Panel";
			this->tbpObj0Panel->Size = System::Drawing::Size(224, 216);
			this->tbpObj0Panel->TabIndex = 0;
			this->tbpObj0Panel->Text = L"Standard";
			this->tbpObj0Panel->UseVisualStyleBackColor = true;
			// 
			// tvObjectList
			// 
			this->tvObjectList->Dock = System::Windows::Forms::DockStyle::Fill;
			this->tvObjectList->DrawMode = System::Windows::Forms::TreeViewDrawMode::OwnerDrawText;
			this->tvObjectList->HideSelection = false;
			this->tvObjectList->Location = System::Drawing::Point(0, 0);
			this->tvObjectList->Margin = System::Windows::Forms::Padding(0);
			this->tvObjectList->Name = L"tvObjectList";
			treeNode1->Name = L"Noeud0";
			treeNode1->Text = L"Common";
			treeNode2->Name = L"Noeud1";
			treeNode2->Text = L"Layer blahblah";
			this->tvObjectList->Nodes->AddRange(gcnew cli::array< System::Windows::Forms::TreeNode^  >(2) {treeNode1, treeNode2});
			this->tvObjectList->ShowLines = false;
			this->tvObjectList->Size = System::Drawing::Size(224, 216);
			this->tvObjectList->TabIndex = 0;
			this->tvObjectList->DrawNode += gcnew System::Windows::Forms::DrawTreeNodeEventHandler(this, &EditorMainForm::tvObjectList_DrawNode);
			this->tvObjectList->BeforeSelect += gcnew System::Windows::Forms::TreeViewCancelEventHandler(this, &EditorMainForm::tvObjectList_BeforeSelect);
			// 
			// tbpObj1Panel
			// 
			this->tbpObj1Panel->Location = System::Drawing::Point(4, 22);
			this->tbpObj1Panel->Margin = System::Windows::Forms::Padding(0);
			this->tbpObj1Panel->Name = L"tbpObj1Panel";
			this->tbpObj1Panel->Size = System::Drawing::Size(224, 216);
			this->tbpObj1Panel->TabIndex = 1;
			this->tbpObj1Panel->Text = L"Simple";
			this->tbpObj1Panel->UseVisualStyleBackColor = true;
			// 
			// tbpObj2Panel
			// 
			this->tbpObj2Panel->Location = System::Drawing::Point(4, 22);
			this->tbpObj2Panel->Name = L"tbpObj2Panel";
			this->tbpObj2Panel->Size = System::Drawing::Size(224, 216);
			this->tbpObj2Panel->TabIndex = 2;
			this->tbpObj2Panel->Text = L"Extra";
			this->tbpObj2Panel->UseVisualStyleBackColor = true;
			// 
			// tlpObjEditPanel
			// 
			this->tlpObjEditPanel->ColumnCount = 2;
			this->tlpObjEditPanel->ColumnStyles->Add((gcnew System::Windows::Forms::ColumnStyle(System::Windows::Forms::SizeType::Absolute, 
				100)));
			this->tlpObjEditPanel->ColumnStyles->Add((gcnew System::Windows::Forms::ColumnStyle()));
			this->tlpObjEditPanel->Dock = System::Windows::Forms::DockStyle::Fill;
			this->tlpObjEditPanel->Location = System::Drawing::Point(0, 0);
			this->tlpObjEditPanel->Name = L"tlpObjEditPanel";
			this->tlpObjEditPanel->RowCount = 9;
			this->tlpObjEditPanel->RowStyles->Add((gcnew System::Windows::Forms::RowStyle(System::Windows::Forms::SizeType::Percent, 100)));
			this->tlpObjEditPanel->RowStyles->Add((gcnew System::Windows::Forms::RowStyle(System::Windows::Forms::SizeType::Absolute, 235)));
			this->tlpObjEditPanel->RowStyles->Add((gcnew System::Windows::Forms::RowStyle(System::Windows::Forms::SizeType::Absolute, 20)));
			this->tlpObjEditPanel->RowStyles->Add((gcnew System::Windows::Forms::RowStyle(System::Windows::Forms::SizeType::Absolute, 20)));
			this->tlpObjEditPanel->RowStyles->Add((gcnew System::Windows::Forms::RowStyle(System::Windows::Forms::SizeType::Absolute, 20)));
			this->tlpObjEditPanel->RowStyles->Add((gcnew System::Windows::Forms::RowStyle(System::Windows::Forms::SizeType::Absolute, 20)));
			this->tlpObjEditPanel->RowStyles->Add((gcnew System::Windows::Forms::RowStyle(System::Windows::Forms::SizeType::Absolute, 20)));
			this->tlpObjEditPanel->RowStyles->Add((gcnew System::Windows::Forms::RowStyle(System::Windows::Forms::SizeType::Absolute, 20)));
			this->tlpObjEditPanel->RowStyles->Add((gcnew System::Windows::Forms::RowStyle(System::Windows::Forms::SizeType::Absolute, 20)));
			this->tlpObjEditPanel->Size = System::Drawing::Size(232, 291);
			this->tlpObjEditPanel->TabIndex = 0;
			// 
			// toolStrip2
			// 
			this->toolStrip2->Items->AddRange(gcnew cli::array< System::Windows::Forms::ToolStripItem^  >(3) {this->btnAddObject, this->btnRemoveObject, 
				this->btnReverseRot});
			this->toolStrip2->Location = System::Drawing::Point(0, 0);
			this->toolStrip2->Name = L"toolStrip2";
			this->toolStrip2->Size = System::Drawing::Size(719, 25);
			this->toolStrip2->TabIndex = 4;
			this->toolStrip2->Text = L"toolStrip2";
			// 
			// btnAddObject
			// 
			this->btnAddObject->DisplayStyle = System::Windows::Forms::ToolStripItemDisplayStyle::Text;
			this->btnAddObject->DropDownItems->AddRange(gcnew cli::array< System::Windows::Forms::ToolStripItem^  >(8) {this->btnAddObj0, 
				this->btnAddObj1, this->btnAddObj2, this->btnAddObj3, this->btnAddObj4, this->btnAddObj5, this->btnAddObj6, this->btnAddObj7});
			this->btnAddObject->Enabled = false;
			this->btnAddObject->Image = (cli::safe_cast<System::Drawing::Image^  >(resources->GetObject(L"btnAddObject.Image")));
			this->btnAddObject->ImageTransparentColor = System::Drawing::Color::Magenta;
			this->btnAddObject->Name = L"btnAddObject";
			this->btnAddObject->Size = System::Drawing::Size(81, 22);
			this->btnAddObject->Text = L"Add object";
			this->btnAddObject->ToolTipText = L"this level lacks Goombas, clearly";
			this->btnAddObject->ButtonClick += gcnew System::EventHandler(this, &EditorMainForm::btnAddObject_ButtonClick);
			// 
			// btnAddObj0
			// 
			this->btnAddObj0->Name = L"btnAddObj0";
			this->btnAddObj0->Size = System::Drawing::Size(115, 22);
			this->btnAddObj0->Tag = L"0";
			this->btnAddObj0->Text = L"All stars";
			this->btnAddObj0->Click += gcnew System::EventHandler(this, &EditorMainForm::btnAddObjN_Click);
			// 
			// btnAddObj1
			// 
			this->btnAddObj1->Name = L"btnAddObj1";
			this->btnAddObj1->Size = System::Drawing::Size(115, 22);
			this->btnAddObj1->Tag = L"1";
			this->btnAddObj1->Text = L"Star 1";
			this->btnAddObj1->Click += gcnew System::EventHandler(this, &EditorMainForm::btnAddObjN_Click);
			// 
			// btnAddObj2
			// 
			this->btnAddObj2->Name = L"btnAddObj2";
			this->btnAddObj2->Size = System::Drawing::Size(115, 22);
			this->btnAddObj2->Tag = L"2";
			this->btnAddObj2->Text = L"Star 2";
			this->btnAddObj2->Click += gcnew System::EventHandler(this, &EditorMainForm::btnAddObjN_Click);
			// 
			// btnAddObj3
			// 
			this->btnAddObj3->Name = L"btnAddObj3";
			this->btnAddObj3->Size = System::Drawing::Size(115, 22);
			this->btnAddObj3->Tag = L"3";
			this->btnAddObj3->Text = L"Star 3";
			this->btnAddObj3->Click += gcnew System::EventHandler(this, &EditorMainForm::btnAddObjN_Click);
			// 
			// btnAddObj4
			// 
			this->btnAddObj4->Name = L"btnAddObj4";
			this->btnAddObj4->Size = System::Drawing::Size(115, 22);
			this->btnAddObj4->Tag = L"4";
			this->btnAddObj4->Text = L"Star 4";
			this->btnAddObj4->Click += gcnew System::EventHandler(this, &EditorMainForm::btnAddObjN_Click);
			// 
			// btnAddObj5
			// 
			this->btnAddObj5->Name = L"btnAddObj5";
			this->btnAddObj5->Size = System::Drawing::Size(115, 22);
			this->btnAddObj5->Tag = L"5";
			this->btnAddObj5->Text = L"Star 5";
			this->btnAddObj5->Click += gcnew System::EventHandler(this, &EditorMainForm::btnAddObjN_Click);
			// 
			// btnAddObj6
			// 
			this->btnAddObj6->Name = L"btnAddObj6";
			this->btnAddObj6->Size = System::Drawing::Size(115, 22);
			this->btnAddObj6->Tag = L"6";
			this->btnAddObj6->Text = L"Star 6";
			this->btnAddObj6->Click += gcnew System::EventHandler(this, &EditorMainForm::btnAddObjN_Click);
			// 
			// btnAddObj7
			// 
			this->btnAddObj7->Name = L"btnAddObj7";
			this->btnAddObj7->Size = System::Drawing::Size(115, 22);
			this->btnAddObj7->Tag = L"7";
			this->btnAddObj7->Text = L"Star 7";
			this->btnAddObj7->Click += gcnew System::EventHandler(this, &EditorMainForm::btnAddObjN_Click);
			// 
			// btnRemoveObject
			// 
			this->btnRemoveObject->DisplayStyle = System::Windows::Forms::ToolStripItemDisplayStyle::Text;
			this->btnRemoveObject->Enabled = false;
			this->btnRemoveObject->Image = (cli::safe_cast<System::Drawing::Image^  >(resources->GetObject(L"btnRemoveObject.Image")));
			this->btnRemoveObject->ImageTransparentColor = System::Drawing::Color::Magenta;
			this->btnRemoveObject->Name = L"btnRemoveObject";
			this->btnRemoveObject->Size = System::Drawing::Size(100, 22);
			this->btnRemoveObject->Text = L"Remove selected";
			// 
			// btnReverseRot
			// 
			this->btnReverseRot->CheckOnClick = true;
			this->btnReverseRot->DisplayStyle = System::Windows::Forms::ToolStripItemDisplayStyle::Text;
			this->btnReverseRot->Image = (cli::safe_cast<System::Drawing::Image^  >(resources->GetObject(L"btnReverseRot.Image")));
			this->btnReverseRot->ImageTransparentColor = System::Drawing::Color::Magenta;
			this->btnReverseRot->Name = L"btnReverseRot";
			this->btnReverseRot->Size = System::Drawing::Size(96, 22);
			this->btnReverseRot->Text = L"Reverse rotation";
			// 
			// sbrStatus
			// 
			this->sbrStatus->Items->AddRange(gcnew cli::array< System::Windows::Forms::ToolStripItem^  >(1) {this->sblStatusLabel});
			this->sbrStatus->Location = System::Drawing::Point(0, 588);
			this->sbrStatus->Name = L"sbrStatus";
			this->sbrStatus->Size = System::Drawing::Size(963, 22);
			this->sbrStatus->TabIndex = 7;
			this->sbrStatus->Text = L"statusStrip1";
			// 
			// sblStatusLabel
			// 
			this->sblStatusLabel->Name = L"sblStatusLabel";
			this->sblStatusLabel->Size = System::Drawing::Size(84, 17);
			this->sblStatusLabel->Text = L"junk goes here";
			// 
			// texexport
			// 
			this->texexport->DefaultExt = L"png";
			this->texexport->Filter = L"PNG image|*.png";
			this->texexport->RestoreDirectory = true;
			this->texexport->Title = L"Save texture to...";
			// 
			// EditorMainForm
			// 
			this->AutoScaleDimensions = System::Drawing::SizeF(6, 13);
			this->AutoScaleMode = System::Windows::Forms::AutoScaleMode::Font;
			this->ClientSize = System::Drawing::Size(963, 610);
			this->Controls->Add(this->sbrStatus);
			this->Controls->Add(this->splitContainer1);
			this->Controls->Add(this->toolStrip1);
			this->Icon = (cli::safe_cast<System::Drawing::Icon^  >(resources->GetObject(L"$this.Icon")));
			this->Name = L"EditorMainForm";
			this->Text = L"EditorMainForm";
			this->Paint += gcnew System::Windows::Forms::PaintEventHandler(this, &EditorMainForm::EditorMainForm_Paint);
			this->FormClosed += gcnew System::Windows::Forms::FormClosedEventHandler(this, &EditorMainForm::EditorMainForm_FormClosed);
			this->toolStrip1->ResumeLayout(false);
			this->toolStrip1->PerformLayout();
			this->ctm3DOptions->ResumeLayout(false);
			this->splitContainer1->Panel1->ResumeLayout(false);
			this->splitContainer1->Panel2->ResumeLayout(false);
			this->splitContainer1->Panel2->PerformLayout();
			this->splitContainer1->ResumeLayout(false);
			this->tbcLeftPanel->ResumeLayout(false);
			this->tbpModelBlox->ResumeLayout(false);
			this->tbpObjects->ResumeLayout(false);
			this->scObjPanelContainer->Panel1->ResumeLayout(false);
			this->scObjPanelContainer->Panel2->ResumeLayout(false);
			this->scObjPanelContainer->ResumeLayout(false);
			this->tbcObjTypeTabs->ResumeLayout(false);
			this->tbpObj0Panel->ResumeLayout(false);
			this->toolStrip2->ResumeLayout(false);
			this->toolStrip2->PerformLayout();
			this->sbrStatus->ResumeLayout(false);
			this->sbrStatus->PerformLayout();
			this->ResumeLayout(false);
			this->PerformLayout();

		}
#pragma endregion

			void ReadObjTable(UInt32 offset);
			void LoadLevelData();
			void DeleteLevelData();
			void FixObjectTable(UInt32 offset, UInt32 fixstart, int delta);
			void AddObject(int type, int layer);

			void PopulateObjList(int type);
			void SetupObjEditPanel(int type);

			List<EditorMainForm^>^ m_EditorList;

			CNitroROM^ m_ROM;
			int m_LevelID;
			UInt32 m_LevelOffset;
			CNitroOverlay^ m_LevelOverlay;
			UInt32 m_BaseRAMAddr;

			CLevelSettings^ m_LevelSettings;
			Byte m_MyBackground;

			typedef array<List<IPositionedObject^>^> TPosObjList;
			TPosObjList^ m_StdObjects;
			TPosObjList^ m_SimpleObjects;
			TPosObjList^ m_ExtraObjects;

			int m_CurObjType, m_SelObjType;
			UInt32 m_LayerMask;

			CBMD^ m_SkyboxModel;
			CBMD^ m_LevelModel;

			array<UInt32>^ m_PickingFrameBuffer;

			// GL stuff
			bool m_GLLoaded;

			Matrix4 m_SkyboxMatrix;
			Matrix4 m_CamMatrix;
			Vector2 m_CamRotation;
			float m_CamDistance;
			Vector3 m_CamPosition;
			Vector3 m_CamTarget;
			bool m_UpsideDown;

			List<IGLGeometry^>^ m_OSkyboxGeometry;
			List<IGLGeometry^>^ m_TSkyboxGeometry;

			List<IGLGeometry^>^ m_OLevelGeometry;
			List<IGLGeometry^>^ m_TLevelGeometry;

			Dictionary<UInt32,CGLG_ObjList^>^ m_ObjCubesList;

			//List<Vector3>^ kcltest;

			UInt32 m_Selection, m_UnderCursor;
			IPositionedObject^ m_SelectedObj;
			CGLG_ObjSelCube^ m_SelCube;
			CGLG_ObjSelCube^ m_HoverCube;

			void BuildSkyboxGeometry();
			void BuildLevelGeometry();
			void BuildGeometry();
			void Render3DMap();
			// end GL stuff

			int m_MouseDown;
			Point m_MouseCoords;
			Point m_LastMouseClick;
			Point m_LastMouseMove;

			float m_PixelFactorX, m_PixelFactorY;


public: 
			int GetLevelID() { return m_LevelID; }
			void UpdateStuff() 
			{ 
				m_LevelOverlay->Update(); 
			}
			void ChangeBackground(int bg)
			{
				m_MyBackground = bg;

				delete m_SkyboxModel;

				if (bg)
				{
					try
					{
						m_SkyboxModel = gcnew CBMD(gcnew CNitroFile(m_ROM, m_ROM->GetFileIDFromName(String::Format("data/vrbox/vr{0:D2}.bmd", bg))));
					}
					catch (Exception^)
					{
						sblStatusLabel->Text = String::Format("Failed to load background 'data/vrbox/vr{0:D2}.bmd'", m_LevelSettings->Background);
						m_SkyboxModel = nullptr;
					}
				}
				else
					m_SkyboxModel = nullptr;

				BuildSkyboxGeometry();
				glc3DView->Refresh();
			}

private:
			void UpdateCamera()
			{
				Vector3 up;

				if ((float)Math::Cos(m_CamRotation.Y) < 0)
				{
					m_UpsideDown = true;
					up = Vector3(0.f, -1.f, 0.f);
				}
				else
				{
					m_UpsideDown = false;
					up = Vector3(0.f, 1.f, 0.f);
				}
					
				m_CamPosition.X = m_CamDistance * (float)Math::Cos(m_CamRotation.X) * (float)Math::Cos(m_CamRotation.Y);
				m_CamPosition.Y = m_CamDistance * (float)Math::Sin(m_CamRotation.Y);
				m_CamPosition.Z = m_CamDistance * (float)Math::Sin(m_CamRotation.X) * (float)Math::Cos(m_CamRotation.Y);

				Vector3 skybox_target;
				skybox_target.X = -(float)Math::Cos(m_CamRotation.X) * (float)Math::Cos(m_CamRotation.Y);
				skybox_target.Y = -(float)Math::Sin(m_CamRotation.Y);
				skybox_target.Z = -(float)Math::Sin(m_CamRotation.X) * (float)Math::Cos(m_CamRotation.Y);

				Vector3::Add(m_CamPosition, m_CamTarget, m_CamPosition);

				m_CamMatrix = Matrix4::LookAt(m_CamPosition, m_CamTarget, up);
				m_SkyboxMatrix = Matrix4::LookAt(Vector3(0.f,0.f,0.f), skybox_target, up);
			}

private: System::Void btnLevelSettings_Click(System::Object^  sender, System::EventArgs^  e) 
		 {
			 LevelSettingsForm^ frm = gcnew LevelSettingsForm(m_LevelSettings);
			 frm->ShowDialog(this);
		 }
private: System::Void btnSaveLevel_Click(System::Object^  sender, System::EventArgs^  e) 
		 {
			 m_ROM->BeginRW();

			 m_LevelSettings->SaveChanges();

			 OBJLISTS;
			 for each (TPosObjList^ ol in objlists)
			 {
				 for (int i = 0; i < 8; i++)
				 {
					 for each (IPositionedObject^ obj in ol[i])
						 obj->SaveChanges();
				 }
			 }

			 m_LevelOverlay->SaveChanges();

			 m_ROM->EndRW();

			 for each (EditorMainForm^ editor in m_EditorList)
				 editor->UpdateStuff();

			 sblStatusLabel->Text = "Level saved";
		 }
private: System::Void EditorMainForm_Paint(System::Object^  sender, System::Windows::Forms::PaintEventArgs^  e) 
		 {
			 if (m_LevelSettings->Background != m_MyBackground)
				 ChangeBackground(m_LevelSettings->Background);
		 }

private: System::Void glc3DView_Load(System::Object^  sender, System::EventArgs^  e) 
		 {
			 m_PickingFrameBuffer = gcnew array<UInt32>(9);
			 m_Selection = 0xFFFFFFFF;
			 m_UnderCursor = 0xFFFFFFFF;
			 m_GLLoaded = true;

			 GL::Viewport(0, 0, glc3DView->Width, glc3DView->Height);
			 
			 float ratio = ((float)glc3DView->Width) / ((float)glc3DView->Height);

			 GL::MatrixMode(MatrixMode::Projection);
			 GL::LoadIdentity();
			 Matrix4 projmtx = Matrix4::CreatePerspectiveFieldOfView((float)((70.f*Math::PI)/180.f), ratio, 0.01f, 1000.f);
			 GL::MultMatrix(projmtx);

			 GL::Enable(EnableCap::DepthTest);

			 m_CamRotation = Vector2(0.f, (float)Math::PI / 8.f);
			// m_CamRotation = Vector2(0.f, 0.f);
			 m_CamTarget = Vector3(5.f, 5.f, 5.f);
			 m_CamDistance = 1.f;//6.5f;
			 UpdateCamera();

			 m_PixelFactorX = ((2.f * (float)Math::Tan((35.f*Math::PI)/180.f) * ratio) / (float)(glc3DView->Width));
			 m_PixelFactorY = ((2.f * (float)Math::Tan((35.f*Math::PI)/180.f)) / (float)(glc3DView->Height));

			 GL::Enable(EnableCap::Blend);
			 GL::BlendFunc(BlendingFactorSrc::SrcAlpha, BlendingFactorDest::OneMinusSrcAlpha);

			 GL::Enable(EnableCap::AlphaTest);
			 GL::AlphaFunc(AlphaFunction::Greater, 0.f);

			 GL::Enable(EnableCap::Texture2D);

			 BuildGeometry();

			 // safety auto-crippling
			 tbcObjTypeTabs->TabPages->RemoveAt(2);
			 btnAddObject->Visible = false;
			 btnRemoveObject->Visible = false;
		 }

private: System::Void glc3DView_Paint(System::Object^  sender, System::Windows::Forms::PaintEventArgs^  e) 
		 {
			 if (!m_GLLoaded) return;
			 glc3DView->Context->MakeCurrent(glc3DView->WindowInfo);

			 Render3DMap();

			 glc3DView->SwapBuffers();
		 }

private: System::Void glc3DView_Resize(System::Object^  sender, System::EventArgs^  e) 
		 {
			 if (!m_GLLoaded) return;
			 glc3DView->Context->MakeCurrent(glc3DView->WindowInfo);

			 GL::Viewport(0, 0, glc3DView->Width, glc3DView->Height);

			 float ratio = ((float)glc3DView->Width) / ((float)glc3DView->Height);

			 GL::MatrixMode(MatrixMode::Projection);
			 GL::LoadIdentity();
			 Matrix4 projmtx = Matrix4::CreatePerspectiveFieldOfView((float)(70.f*Math::PI/180.f), ratio, 0.05f, 1000.f);
			 GL::MultMatrix(projmtx);

			 m_PixelFactorX = ((2.f * (float)Math::Tan((35.f*Math::PI)/180.f) * ratio) / (float)(glc3DView->Width));
			 m_PixelFactorY = ((2.f * (float)Math::Tan((35.f*Math::PI)/180.f)) / (float)(glc3DView->Height));
		 }

private: System::Void EditorMainForm_FormClosed(System::Object^  sender, System::Windows::Forms::FormClosedEventArgs^  e) 
		 {
			 //
		 }

private: System::Void glc3DView_MouseDown(System::Object^  sender, System::Windows::Forms::MouseEventArgs^  e) 
		 {
			 if (m_MouseDown != 0) return;

			 if ((m_PickingFrameBuffer[1] == m_PickingFrameBuffer[4]) &&
				 (m_PickingFrameBuffer[3] == m_PickingFrameBuffer[4]) &&
				 (m_PickingFrameBuffer[5] == m_PickingFrameBuffer[4]) &&
				 (m_PickingFrameBuffer[7] == m_PickingFrameBuffer[4]))
			 {
				 UInt32 selection = m_PickingFrameBuffer[4];
				 UInt32 type = selection >> 28;

				 if (type != 0xF)
				 {
					 OBJLISTS;
					 IPositionedObject^ obj = objlists[type][(selection >> 24) & 0xF][selection & 0x00FFFFFF];

					 if (type != (m_Selection >> 28))
					 {
						switch (type)
						{
						case 0: tbcLeftPanel->SelectedIndex = 1; tbcObjTypeTabs->SelectedIndex = 0; break;
						case 1: tbcLeftPanel->SelectedIndex = 1; tbcObjTypeTabs->SelectedIndex = 1; break;
						case 2: tbcLeftPanel->SelectedIndex = 1; tbcObjTypeTabs->SelectedIndex = 2; break;
						}
					 }

					 m_SelectedObj = obj;
					 m_SelCube->Update(obj);
					 SetupObjEditPanel(type);
					 obj->FillEditPanel(tlpObjEditPanel, 0x0);

					 tvObjectList->SelectedNode = tvObjectList->Nodes->Find(String::Format("{0:X8}", selection), true)[0];
					 tvObjectList->SelectedNode->EnsureVisible();
					 
					 m_Selection = selection;
				 }

				 m_UnderCursor = selection;
			 }
			 else
				 m_UnderCursor = 0xFFFFFFFF;

			 if (e->Button == System::Windows::Forms::MouseButtons::Left)
				 m_MouseDown = 1;
			 else if (e->Button == System::Windows::Forms::MouseButtons::Right)
				 m_MouseDown = 2;
			 else
				 return;

			 m_LastMouseClick = e->Location;
			 m_LastMouseMove = e->Location;
		 }
private: System::Void glc3DView_MouseUp(System::Object^  sender, System::Windows::Forms::MouseEventArgs^  e)
		 {
			 if (m_MouseDown == 1)
			 {
				 if (e->Button != System::Windows::Forms::MouseButtons::Left)
					 return;
			 }
			 else if (m_MouseDown == 2)
			 {
				 if (e->Button != System::Windows::Forms::MouseButtons::Right)
					 return;
			 }
			 else
				 return;

			 if (((m_Selection >> 28) != 0xF) && ((m_UnderCursor >> 28) == 0xF))
			 {
				 if ((Math::Abs(e->Location.X - m_LastMouseClick.X) < 3) && (Math::Abs(e->Location.Y - m_LastMouseClick.Y) < 3))
				 {
					 m_Selection = 0xFFFFFFFF;
					 m_SelCube->Update(nullptr); 
					 SetupObjEditPanel(-1);
					 tvObjectList->SelectedNode = nullptr;
				 }
			 }

			 m_MouseDown = 0;
		 }
private: System::Void glc3DView_MouseMove(System::Object^  sender, System::Windows::Forms::MouseEventArgs^  e) 
		 {
			 float xdelta = (float)(e->X - m_LastMouseMove.X);
			 float ydelta = (float)(e->Y - m_LastMouseMove.Y);
			 
			 m_MouseCoords = e->Location;
			 m_LastMouseMove = e->Location;

			 if (m_MouseDown != 0)
			 {
				 if ((m_UnderCursor >> 28) == 0xF)
				 {
					 if (m_MouseDown == 2)
					 {
						 if (btnReverseRot->Checked)
						 {
							 xdelta = -xdelta;
							 ydelta = -ydelta;
						 }

						 if (m_UpsideDown)
							 xdelta = -xdelta;

						 m_CamRotation.X -= xdelta*0.002f;
						 m_CamRotation.Y -= ydelta*0.002f;

						 ClampRotation(m_CamRotation.X, (float)Math::PI * 2.f);
						 ClampRotation(m_CamRotation.Y, (float)Math::PI * 2.f);
					 }
					 else if (m_MouseDown == 1)
					 {
						 xdelta *= 0.005f;
						 ydelta *= 0.005f;

						 m_CamTarget.X -= xdelta * (float)Math::Sin(m_CamRotation.X);
						 m_CamTarget.X -= ydelta * (float)Math::Cos(m_CamRotation.X) * (float)Math::Sin(m_CamRotation.Y);
						 m_CamTarget.Y += ydelta * (float)Math::Cos(m_CamRotation.Y);
						 m_CamTarget.Z += xdelta * (float)Math::Cos(m_CamRotation.X);
						 m_CamTarget.Z -= ydelta * (float)Math::Sin(m_CamRotation.X) * (float)Math::Sin(m_CamRotation.Y);
					 }

					 UpdateCamera();
				 }
				 else
				 {
					 if (m_MouseDown == 2)
					 {
						 if (m_UpsideDown)
							 xdelta = -xdelta;

						 // TODO take obj/camera rotation into account?
						 m_SelectedObj->YRot += xdelta * 0.05f;
						 
						 if (m_SelectedObj->YRot >= 8.f)
						 {
							 m_SelectedObj->YRot = -16.f + m_SelectedObj->YRot;
						 }
						 else if (m_SelectedObj->YRot < -8.f)
						 {
							 m_SelectedObj->YRot = 16.f + m_SelectedObj->YRot;
						 }

						 m_ObjCubesList[m_SelectedObj->m_UniqueID & 0xFF000000]->Update(m_SelectedObj->m_UniqueID & 0x00FFFFFF);
						 m_SelCube->Update(m_SelectedObj);
						 m_SelectedObj->FillEditPanel(tlpObjEditPanel, 0x1);
					 }
					 else if (m_MouseDown == 1)
					 {
						 Vector3 objpos = Vector3(m_SelectedObj->XPos, m_SelectedObj->YPos, m_SelectedObj->ZPos);
						 Vector3 between;
						 Vector3::Subtract(m_CamPosition, objpos, between);

						 float objz = (((between.X * (float)Math::Cos(m_CamRotation.X)) + (between.Z * (float)Math::Sin(m_CamRotation.X))) * (float)Math::Cos(m_CamRotation.Y)) + (between.Y * (float)Math::Sin(m_CamRotation.Y));

						 xdelta *= m_PixelFactorX * objz;
						 ydelta *= -m_PixelFactorY * objz;

						 float _xdelta = (xdelta * (float)Math::Sin(m_CamRotation.X)) - (ydelta * (float)Math::Sin(m_CamRotation.Y) * (float)Math::Cos(m_CamRotation.X));
						 float _ydelta = ydelta * (float)Math::Cos(m_CamRotation.Y);
						 float _zdelta = (xdelta * (float)Math::Cos(m_CamRotation.X)) + (ydelta * (float)Math::Sin(m_CamRotation.Y) * (float)Math::Sin(m_CamRotation.X));
						 
						 m_SelectedObj->XPos += _xdelta;
						 m_SelectedObj->YPos += _ydelta;
						 m_SelectedObj->ZPos -= _zdelta;

						 m_ObjCubesList[m_SelectedObj->m_UniqueID & 0xFF000000]->Update(m_SelectedObj->m_UniqueID & 0x00FFFFFF);
						 m_SelCube->Update(m_SelectedObj);
						 m_SelectedObj->FillEditPanel(tlpObjEditPanel, 0x1);
					 }
				 }
			 }
			 else
			 {
				 if ((m_PickingFrameBuffer[1] == m_PickingFrameBuffer[4]) &&
					 (m_PickingFrameBuffer[3] == m_PickingFrameBuffer[4]) &&
					 (m_PickingFrameBuffer[5] == m_PickingFrameBuffer[4]) &&
					 (m_PickingFrameBuffer[7] == m_PickingFrameBuffer[4]))
				 {
					 UInt32 selection = m_PickingFrameBuffer[4];

					 if ((selection >> 28) == 0xF)
					 {
						 m_HoverCube->Update(nullptr);
					 }
					 else
					 {
						 OBJLISTS;
						 m_HoverCube->Update(objlists[selection >> 28][(selection >> 24) & 0xF][selection & 0x00FFFFFF]);
					 }
				 }
			 }

			 glc3DView->Refresh();
		 }

private: System::Void glc3DView_MouseWheel(System::Object^  sender, System::Windows::Forms::MouseEventArgs^  e) 
		 {
			 if ((m_MouseDown == 1) && ((m_Selection >> 28) != 0xF))
			 {
				 float delta = -(e->Delta/120.f);
				 delta = (float)Math::Pow(delta, 3.f) * 0.05f;

				 m_SelectedObj->XPos += delta * (float)Math::Cos(m_CamRotation.X) * (float)Math::Cos(m_CamRotation.Y);
				 m_SelectedObj->YPos += delta * (float)Math::Sin(m_CamRotation.Y);
				 m_SelectedObj->ZPos += delta * (float)Math::Sin(m_CamRotation.X) * (float)Math::Cos(m_CamRotation.Y);

				 float xdist = delta * (m_MouseCoords.X - (glc3DView->Width / 2.f)) * m_PixelFactorX;
				 float ydist = delta * (m_MouseCoords.Y - (glc3DView->Height / 2.f)) * m_PixelFactorY;

				 m_SelectedObj->XPos -= (xdist * (float)Math::Sin(m_CamRotation.X)) + (ydist * (float)Math::Sin(m_CamRotation.Y) * (float)Math::Cos(m_CamRotation.X));
				 m_SelectedObj->YPos += ydist * (float)Math::Cos(m_CamRotation.Y);
				 m_SelectedObj->ZPos += (xdist * (float)Math::Cos(m_CamRotation.X)) - (ydist * (float)Math::Sin(m_CamRotation.Y) * (float)Math::Sin(m_CamRotation.X));

				 m_ObjCubesList[m_SelectedObj->m_UniqueID & 0xFF000000]->Update(m_SelectedObj->m_UniqueID & 0x00FFFFFF);
				 m_SelCube->Update(m_SelectedObj);
				 m_SelectedObj->FillEditPanel(tlpObjEditPanel, 0x1);
			 }
			 else
			 {
				 float delta = -((e->Delta/120.f)*0.1f);
				 m_CamTarget.X += delta * (float)Math::Cos(m_CamRotation.X) * (float)Math::Cos(m_CamRotation.Y);
				 m_CamTarget.Y += delta * (float)Math::Sin(m_CamRotation.Y);
				 m_CamTarget.Z += delta * (float)Math::Sin(m_CamRotation.X) * (float)Math::Cos(m_CamRotation.Y);
				// m_CamDistance += delta*2.f;
				// if (m_CamDistance < 0.01f) m_CamDistance = 0.01f;

				 UpdateCamera();
			 }

			 glc3DView->Refresh();
		 }

private: System::Void tvModelBlocks_AfterCheck(System::Object^  sender, System::Windows::Forms::TreeViewEventArgs^  e) 
		 {
			 if (e->Node->Level == 0)
			 {
				 for each (TreeNode^ child in e->Node->Nodes)
					 ((IGLGeometry^)child->Tag)->Toggle(e->Node->Checked && child->Checked);
			 }
			 else if (e->Node->Level == 1)
				 ((IGLGeometry^)e->Node->Tag)->Toggle(e->Node->Checked && e->Node->Parent->Checked);

			 glc3DView->Refresh();
		 }

private: System::Void btnLayerN_Click(System::Object^  sender, System::EventArgs^  e) 
		 {
			 ToolStripButton^ btn = (ToolStripButton^)sender;
			 UInt32 mytag = UInt32::Parse((String^)btn->Tag);

			 if (btn->Checked)
			 {
				 array<ToolStripButton^>^ btns = {btnLayer1, btnLayer2, btnLayer3, btnLayer4, btnLayer5, btnLayer6, btnLayer7};
				 for each (ToolStripButton^ test in btns)
				 {
					 if (UInt32::Parse((String^)test->Tag) != mytag)
						 test->Checked = false;
				 }

				 m_LayerMask = (m_LayerMask & 0x01) | (1 << mytag);
			 }
			 else
				 m_LayerMask &= 0x01;

			 PopulateObjList(m_CurObjType);

			 for each (KeyValuePair<UInt32,CGLG_ObjList^>^ ol in m_ObjCubesList)
				 ol->Value->SetLayerMask(m_LayerMask);
			 
			 glc3DView->Refresh();
		 }
private: System::Void btnLayer0_Click(System::Object^  sender, System::EventArgs^  e) 
		 {
			 m_LayerMask = (m_LayerMask & 0xFE) | (btnLayer0->Checked ? 0x01 : 0x00);

			 PopulateObjList(m_CurObjType);

			 for each (KeyValuePair<UInt32,CGLG_ObjList^>^ ol in m_ObjCubesList)
				 ol->Value->SetLayerMask(m_LayerMask);

			 glc3DView->Refresh();
		 }

private: System::Void objParamChanged(System::Object^ sender, System::EventArgs^ e)
		 {
			 int id = tlpObjEditPanel->Controls->IndexOf((Control^)sender);

			 m_SelectedObj->UpdateFromEditPanel(tlpObjEditPanel, id);
			 m_ObjCubesList[m_SelectedObj->m_UniqueID & 0xFF000000]->Update(m_SelectedObj->m_UniqueID & 0x00FFFFFF);
			 m_SelCube->Update(m_SelectedObj);

			 glc3DView->Refresh();
		 }

private: System::Void tvObjectList_BeforeSelect(System::Object^  sender, System::Windows::Forms::TreeViewCancelEventArgs^  e) 
		 {
			 if (e->Node->Level != 1)
			 {
				 SetupObjEditPanel(-1);
				 m_Selection = 0xFFFFFFFF;
				 m_SelCube->Update(nullptr);
				 return;
			 }

			 IPositionedObject^ obj = (IPositionedObject^)e->Node->Tag;

			 m_Selection = obj->m_UniqueID;
			 m_SelectedObj = obj;
			 int type = m_Selection >> 28;

			 m_SelCube->Update(obj);

			 SetupObjEditPanel(type);
			 obj->FillEditPanel(tlpObjEditPanel, 0x0);

			 tlpObjEditPanel->Refresh();
			 glc3DView->Refresh();
		 }

private: System::Void tvObjectList_DrawNode(System::Object^  sender, System::Windows::Forms::DrawTreeNodeEventArgs^  e) 
		 {
			 Color fgcolor, bgcolor;

			 Drawing::Font^ font = e->Node->NodeFont;
			 if (font == nullptr) font = tvObjectList->Font;

			 if ((e->State & (TreeNodeStates::Selected | TreeNodeStates::Focused)) != (TreeNodeStates)0)
			 {
				 fgcolor = SystemColors::HighlightText;
				 bgcolor = SystemColors::Highlight;
			 }
			 else
			 {
				 fgcolor = SystemColors::WindowText;
				 bgcolor = SystemColors::Window;
			 }
			
			 e->Graphics->FillRectangle(gcnew SolidBrush(bgcolor), e->Bounds);
			 e->Graphics->DrawString(e->Node->Text, font, gcnew SolidBrush(fgcolor), (float)e->Bounds.X, (float)(e->Bounds.Y + 1));
		 }

private: System::Void tbcObjTypeTabs_SelectedIndexChanged(System::Object^  sender, System::EventArgs^  e) 
		 {
			 int type = -1;

			 switch (tbcLeftPanel->SelectedIndex)
			 {
			 case 1:
				 switch (tbcObjTypeTabs->SelectedIndex) 
				 {
				 case 0: type = 0; break;
				 case 1: type = 1; break;
				 case 2: type = 2; break;
				 }
				 break;

				 // more go here

			 default: return;
			 }

			 m_CurObjType = type;
			 PopulateObjList(type);

			 tvObjectList->Parent = tbcObjTypeTabs->SelectedTab;
		 }
private: System::Void tbcLeftPanel_SelectedIndexChanged(System::Object^  sender, System::EventArgs^  e) 
		 {
			 tbcObjTypeTabs->SelectedIndex = 0;
		 }
private: System::Void btnAddObject_ButtonClick(System::Object^  sender, System::EventArgs^  e) 
		 {
			 int layer = 0;

			 if (!(m_LayerMask & 0x01))
			 {
				 while ((!(m_LayerMask & (1 << layer))) && (layer < 8))
					 layer++;

				 if (layer > 7)
					 layer = 0;
			 }

			 AddObject(m_CurObjType, layer);
		 }
private: System::Void btnAddObjN_Click(System::Object^  sender, System::EventArgs^  e) 
		 {
			 AddObject(m_CurObjType, int::Parse((String^)((ToolStripMenuItem^)sender)->Tag));
		 }

private: System::Void glc3DView_KeyDown(System::Object^  sender, System::Windows::Forms::KeyEventArgs^  e) 
		 {
			 // are you happy Niko :P

			 if ((m_Selection >> 28) != 0xF)
			 {
				 float xdelta = 0.f;
				 float ydelta = 0.f;
				 float zdelta = 0.f;
				 bool need_update = false;

				 if ((e->KeyCode == Keys::D) || (e->KeyCode == Keys::NumPad6))
					 xdelta = 5.f;
				 else if ((e->KeyCode == Keys::A) || (e->KeyCode == Keys::NumPad4))
					 xdelta = -5.f;
				 else if ((e->KeyCode == Keys::W) || (e->KeyCode == Keys::NumPad8))
					 ydelta = -5.f;
				 else if ((e->KeyCode == Keys::S) || (e->KeyCode == Keys::NumPad2))
					 ydelta = 5.f;
				 else if ((e->KeyCode == Keys::E) || (e->KeyCode == Keys::NumPad9))
					 zdelta = -0.05f;
				 else if ((e->KeyCode == Keys::Z) || (e->KeyCode == Keys::NumPad1))
					 zdelta = 0.05f;

				 if ((xdelta != 0.f) || (ydelta != 0.f))
				 {
					 if (m_UpsideDown)
						 xdelta = -xdelta;

					 Vector3 objpos = Vector3(m_SelectedObj->XPos, m_SelectedObj->YPos, m_SelectedObj->ZPos);
					 Vector3 between;
					 Vector3::Subtract(m_CamPosition, objpos, between);

					 float objz = (((between.X * (float)Math::Cos(m_CamRotation.X)) + (between.Z * (float)Math::Sin(m_CamRotation.X))) * (float)Math::Cos(m_CamRotation.Y)) + (between.Y * (float)Math::Sin(m_CamRotation.Y));

					 xdelta *= m_PixelFactorX * objz;
					 ydelta *= -m_PixelFactorY * objz;

					 float _xdelta = (xdelta * (float)Math::Sin(m_CamRotation.X)) - (ydelta * (float)Math::Sin(m_CamRotation.Y) * (float)Math::Cos(m_CamRotation.X));
					 float _ydelta = ydelta * (float)Math::Cos(m_CamRotation.Y);
					 float _zdelta = (xdelta * (float)Math::Cos(m_CamRotation.X)) + (ydelta * (float)Math::Sin(m_CamRotation.Y) * (float)Math::Sin(m_CamRotation.X));
					 
					 m_SelectedObj->XPos += _xdelta;
					 m_SelectedObj->YPos += _ydelta;
					 m_SelectedObj->ZPos -= _zdelta;

					 need_update = true;
				 }

#if 0
				 if (zdelta != 0.f)
				 {
					 Vector3 objpos = Vector3(m_SelectedObj->XPos, m_SelectedObj->YPos, m_SelectedObj->ZPos);
					 Vector3 between;
					 Vector3::Subtract(m_CamPosition, objpos, between);

					 float objz = (((between.X * (float)Math::Cos(m_CamRotation.X)) + (between.Z * (float)Math::Sin(m_CamRotation.X))) * (float)Math::Cos(m_CamRotation.Y)) + (between.Y * (float)Math::Sin(m_CamRotation.Y));

					 float xcoord = ((-between.X * (float)Math::Sin(m_CamRotation.X)) + (between.Z * (float)Math::Cos(m_CamRotation.X))) * (float)Math::Cos(m_CamRotation.Y);
					 xcoord /= objz;
					 float ycoord = (between.Y * (float)Math::Sin(m_CamRotation.Y)) + ((-between.X * (float)Math::Cos(m_CamRotation.X)) + (between.Z * (float)Math::Sin(m_CamRotation.X))) * (float)Math::Cos(m_CamRotation.Y);
					 ycoord /= objz;

					 m_SelectedObj->XPos += zdelta * (float)Math::Cos(m_CamRotation.X) * (float)Math::Cos(m_CamRotation.Y);
					 m_SelectedObj->YPos += zdelta * (float)Math::Sin(m_CamRotation.Y);
					 m_SelectedObj->ZPos += zdelta * (float)Math::Sin(m_CamRotation.X) * (float)Math::Cos(m_CamRotation.Y);

					 float xdist = zdelta * xcoord;
					 float ydist = zdelta * ycoord;

					 m_SelectedObj->XPos += (xdist * (float)Math::Sin(m_CamRotation.X) * (float)Math::Cos(m_CamRotation.Y)) - (ydist * (float)Math::Cos(m_CamRotation.Y) * (float)Math::Cos(m_CamRotation.X));
					 m_SelectedObj->YPos += ydist * (float)Math::Sin(m_CamRotation.Y);
					 m_SelectedObj->ZPos += (xdist * (float)Math::Cos(m_CamRotation.X) * (float)Math::Cos(m_CamRotation.Y)) + (ydist * (float)Math::Cos(m_CamRotation.Y) * (float)Math::Sin(m_CamRotation.X));

					 need_update = true;
				 }
#endif

				 if (need_update)
				 {
					 m_ObjCubesList[m_SelectedObj->m_UniqueID & 0xFF000000]->Update(m_SelectedObj->m_UniqueID & 0x00FFFFFF);
					 m_SelCube->Update(m_SelectedObj);
					 m_SelectedObj->FillEditPanel(tlpObjEditPanel, 0x1);
				 }
			 }
		 }
private: System::Void btnDumpTexture_Click(System::Object^  sender, System::EventArgs^  e) 
		 {
			 if (!tvModelBlocks->SelectedNode) return;
			 if (tvModelBlocks->SelectedNode->Level != 1) return;

			 int pidx = tvModelBlocks->SelectedNode->Parent->Index;
			 int idx = tvModelBlocks->SelectedNode->Index;

			 CBMD::CModelChunk^ mdchunk = m_LevelModel->m_ModelChunks[pidx];
			 CBMD::CMatPolyPair^ mppair = mdchunk->m_MatPolyPairs[idx];

			 if (mppair->m_Texture == nullptr)
			 {
				 sblStatusLabel->Text = String::Format("'{0}/{1}' has no texture associated.", mdchunk->m_Name, mppair->m_Name);
				 return;
			 }

			 texexport->Title = String::Format("Save texture '{0}' from '{1}/{2}'", mppair->m_TexName, mdchunk->m_Name, mppair->m_Name);
			 texexport->FileName = String::Concat(mppair->m_TexName, ".png");
			 if (texexport->ShowDialog(this) == Windows::Forms::DialogResult::OK)
			 {
				unsigned char* durrptr = new unsigned char[4*mppair->m_TexWidth*mppair->m_TexHeight];
				Runtime::InteropServices::Marshal::Copy(mppair->m_Texture, 0, IntPtr(durrptr), mppair->m_Texture->Length);

				Drawing::Image^ img = gcnew Drawing::Bitmap(mppair->m_TexWidth, mppair->m_TexHeight, mppair->m_TexWidth * 4, Drawing::Imaging::PixelFormat::Format32bppArgb, IntPtr(durrptr));
				img->Save(texexport->FileName, Drawing::Imaging::ImageFormat::Png);

				delete img;
				delete[] durrptr;

				sblStatusLabel->Text = String::Format("Texture from '{0}/{1}' successfully saved.", mdchunk->m_Name, mppair->m_Name);
			 }
		 }
private: System::Void tvModelBlocks_MouseClick(System::Object^  sender, System::Windows::Forms::MouseEventArgs^  e) 
		 {
			 if (e->Button == Windows::Forms::MouseButtons::Right)
			 {
				 TreeViewHitTestInfo^ htinfo = tvModelBlocks->HitTest(e->Location);
				 tvModelBlocks->SelectedNode = htinfo->Node;

				 if (htinfo->Node)
					 if (htinfo->Node->Level == 1)
						ctm3DOptions->Show(tvModelBlocks, e->Location);
			 }
		 }
};

}
