#pragma once

using namespace System;
using namespace System::ComponentModel;
using namespace System::Collections;
using namespace System::Windows::Forms;
using namespace System::Data;
using namespace System::Drawing;
using namespace System::Collections;
using namespace System::Collections::Generic;

#include "NitroROM.h"
#include "NitroOverlay.h"
#include "levelclasses.h"


namespace sm64ds_editor
{
	/// <summary>
	/// Description rsume de LevelSettingsForm
	///
	/// AVERTISSEMENT: si vous modifiez le nom de cette classe, vous devrez modifier la
	///          proprit 'Nom du fichier de ressources' de l'outil de compilation de ressource manage
	///          pour tous les fichiers .resx dont dpend cette classe. Dans le cas contraire,
	///          les concepteurs ne pourront pas interagir correctement avec les ressources
	///          localises associes  ce formulaire.
	/// </summary>
	public ref class LevelSettingsForm : public System::Windows::Forms::Form
	{
	public:
		LevelSettingsForm(CLevelSettings^ ls)
		{
			InitializeComponent();

			m_LevelSettings = ls;
			cbxSkySetting->SelectedIndex = m_LevelSettings->Background;
			cbxBank0->SelectedIndex = m_LevelSettings->ObjBanks[0];
			cbxBank1->SelectedIndex = m_LevelSettings->ObjBanks[1];
			cbxBank2->SelectedIndex = m_LevelSettings->ObjBanks[2];
			cbxBank3->SelectedIndex = m_LevelSettings->ObjBanks[3];
			cbxBank4->SelectedIndex = m_LevelSettings->ObjBanks[4];
			cbxBank5->SelectedIndex = m_LevelSettings->ObjBanks[5];
			cbxBank6->SelectedIndex = m_LevelSettings->ObjBanks[6];

			m_PrevBackground = m_LevelSettings->Background;
		}

	protected:
		/// <summary>
		/// Nettoyage des ressources utilises.
		/// </summary>
		~LevelSettingsForm()
		{
			if (components)
			{
				delete components;
			}
		}
	private: System::Windows::Forms::Label^  label1;
	private: System::Windows::Forms::ComboBox^  cbxSkySetting;

	private: System::Windows::Forms::Button^  btnOk;
	private: System::Windows::Forms::Button^  btnCancel;
	private: System::Windows::Forms::GroupBox^  groupBox1;
	private: System::Windows::Forms::GroupBox^  groupBox2;
	private: System::Windows::Forms::ComboBox^  cbxBank0;
	private: System::Windows::Forms::Label^  label3;
	private: System::Windows::Forms::Label^  label2;
	private: System::Windows::Forms::ComboBox^  cbxBank1;
	private: System::Windows::Forms::ComboBox^  cbxBank2;
	private: System::Windows::Forms::ComboBox^  cbxBank3;
	private: System::Windows::Forms::ComboBox^  cbxBank4;
	private: System::Windows::Forms::ComboBox^  cbxBank5;
	private: System::Windows::Forms::ComboBox^  cbxBank6;
	private: System::Windows::Forms::Label^  label8;
	private: System::Windows::Forms::Label^  label7;
	private: System::Windows::Forms::Label^  label6;
	private: System::Windows::Forms::Label^  label5;
	private: System::Windows::Forms::Label^  label4;


	protected: 

	private:
		/// <summary>
		/// Variable ncessaire au concepteur.
		/// </summary>
		System::ComponentModel::Container ^components;

#pragma region Windows Form Designer generated code
		/// <summary>
		/// Mthode requise pour la prise en charge du concepteur - ne modifiez pas
		/// le contenu de cette mthode avec l'diteur de code.
		/// </summary>
		void InitializeComponent(void)
		{
			this->label1 = (gcnew System::Windows::Forms::Label());
			this->cbxSkySetting = (gcnew System::Windows::Forms::ComboBox());
			this->btnOk = (gcnew System::Windows::Forms::Button());
			this->btnCancel = (gcnew System::Windows::Forms::Button());
			this->groupBox1 = (gcnew System::Windows::Forms::GroupBox());
			this->groupBox2 = (gcnew System::Windows::Forms::GroupBox());
			this->label8 = (gcnew System::Windows::Forms::Label());
			this->label7 = (gcnew System::Windows::Forms::Label());
			this->label6 = (gcnew System::Windows::Forms::Label());
			this->label5 = (gcnew System::Windows::Forms::Label());
			this->label4 = (gcnew System::Windows::Forms::Label());
			this->cbxBank6 = (gcnew System::Windows::Forms::ComboBox());
			this->cbxBank5 = (gcnew System::Windows::Forms::ComboBox());
			this->label3 = (gcnew System::Windows::Forms::Label());
			this->cbxBank4 = (gcnew System::Windows::Forms::ComboBox());
			this->cbxBank3 = (gcnew System::Windows::Forms::ComboBox());
			this->cbxBank2 = (gcnew System::Windows::Forms::ComboBox());
			this->cbxBank1 = (gcnew System::Windows::Forms::ComboBox());
			this->cbxBank0 = (gcnew System::Windows::Forms::ComboBox());
			this->label2 = (gcnew System::Windows::Forms::Label());
			this->groupBox1->SuspendLayout();
			this->groupBox2->SuspendLayout();
			this->SuspendLayout();
			// 
			// label1
			// 
			this->label1->AutoSize = true;
			this->label1->Location = System::Drawing::Point(6, 26);
			this->label1->Name = L"label1";
			this->label1->Size = System::Drawing::Size(71, 13);
			this->label1->TabIndex = 0;
			this->label1->Text = L"Background: ";
			// 
			// cbxSkySetting
			// 
			this->cbxSkySetting->DropDownStyle = System::Windows::Forms::ComboBoxStyle::DropDownList;
			this->cbxSkySetting->FormattingEnabled = true;
			this->cbxSkySetting->Items->AddRange(gcnew cli::array< System::Object^  >(12) {L"[0] None", L"[1] Sea", L"[2] Sky", L"[3] Cloudy sky", 
				L"[4] Snowy mountains", L"[5] Ghastly forest", L"[6] Desert", L"[7] Flaming sky", L"[8] Underwater city", L"[9] Foggy forest", 
				L"[10] Bowser in the Dark World", L"[11] Bowser in the Sky"});
			this->cbxSkySetting->Location = System::Drawing::Point(83, 23);
			this->cbxSkySetting->Name = L"cbxSkySetting";
			this->cbxSkySetting->Size = System::Drawing::Size(296, 21);
			this->cbxSkySetting->TabIndex = 1;
			this->cbxSkySetting->SelectedIndexChanged += gcnew System::EventHandler(this, &LevelSettingsForm::cbxSkySetting_SelectedIndexChanged);
			// 
			// btnOk
			// 
			this->btnOk->Location = System::Drawing::Point(334, 304);
			this->btnOk->Name = L"btnOk";
			this->btnOk->Size = System::Drawing::Size(75, 23);
			this->btnOk->TabIndex = 3;
			this->btnOk->Text = L"Ok";
			this->btnOk->UseVisualStyleBackColor = true;
			this->btnOk->Click += gcnew System::EventHandler(this, &LevelSettingsForm::btnOk_Click);
			// 
			// btnCancel
			// 
			this->btnCancel->DialogResult = System::Windows::Forms::DialogResult::Cancel;
			this->btnCancel->Location = System::Drawing::Point(253, 304);
			this->btnCancel->Name = L"btnCancel";
			this->btnCancel->Size = System::Drawing::Size(75, 23);
			this->btnCancel->TabIndex = 4;
			this->btnCancel->Text = L"Cancel";
			this->btnCancel->UseVisualStyleBackColor = true;
			// 
			// groupBox1
			// 
			this->groupBox1->Controls->Add(this->label1);
			this->groupBox1->Controls->Add(this->cbxSkySetting);
			this->groupBox1->Location = System::Drawing::Point(12, 12);
			this->groupBox1->Name = L"groupBox1";
			this->groupBox1->Size = System::Drawing::Size(396, 60);
			this->groupBox1->TabIndex = 5;
			this->groupBox1->TabStop = false;
			this->groupBox1->Text = L"General settings";
			// 
			// groupBox2
			// 
			this->groupBox2->Controls->Add(this->label8);
			this->groupBox2->Controls->Add(this->label7);
			this->groupBox2->Controls->Add(this->label6);
			this->groupBox2->Controls->Add(this->label5);
			this->groupBox2->Controls->Add(this->label4);
			this->groupBox2->Controls->Add(this->cbxBank6);
			this->groupBox2->Controls->Add(this->cbxBank5);
			this->groupBox2->Controls->Add(this->label3);
			this->groupBox2->Controls->Add(this->cbxBank4);
			this->groupBox2->Controls->Add(this->cbxBank3);
			this->groupBox2->Controls->Add(this->cbxBank2);
			this->groupBox2->Controls->Add(this->cbxBank1);
			this->groupBox2->Controls->Add(this->cbxBank0);
			this->groupBox2->Controls->Add(this->label2);
			this->groupBox2->Location = System::Drawing::Point(12, 78);
			this->groupBox2->Name = L"groupBox2";
			this->groupBox2->Size = System::Drawing::Size(396, 220);
			this->groupBox2->TabIndex = 6;
			this->groupBox2->TabStop = false;
			this->groupBox2->Text = L"Object banks";
			// 
			// label8
			// 
			this->label8->AutoSize = true;
			this->label8->Location = System::Drawing::Point(6, 188);
			this->label8->Name = L"label8";
			this->label8->Size = System::Drawing::Size(44, 13);
			this->label8->TabIndex = 7;
			this->label8->Text = L"Bank 6:";
			// 
			// label7
			// 
			this->label7->AutoSize = true;
			this->label7->Location = System::Drawing::Point(6, 161);
			this->label7->Name = L"label7";
			this->label7->Size = System::Drawing::Size(44, 13);
			this->label7->TabIndex = 7;
			this->label7->Text = L"Bank 5:";
			// 
			// label6
			// 
			this->label6->AutoSize = true;
			this->label6->Location = System::Drawing::Point(6, 134);
			this->label6->Name = L"label6";
			this->label6->Size = System::Drawing::Size(44, 13);
			this->label6->TabIndex = 7;
			this->label6->Text = L"Bank 4:";
			// 
			// label5
			// 
			this->label5->AutoSize = true;
			this->label5->Location = System::Drawing::Point(6, 107);
			this->label5->Name = L"label5";
			this->label5->Size = System::Drawing::Size(44, 13);
			this->label5->TabIndex = 7;
			this->label5->Text = L"Bank 3:";
			// 
			// label4
			// 
			this->label4->AutoSize = true;
			this->label4->Location = System::Drawing::Point(6, 80);
			this->label4->Name = L"label4";
			this->label4->Size = System::Drawing::Size(44, 13);
			this->label4->TabIndex = 7;
			this->label4->Text = L"Bank 2:";
			// 
			// cbxBank6
			// 
			this->cbxBank6->DropDownStyle = System::Windows::Forms::ComboBoxStyle::DropDownList;
			this->cbxBank6->FormattingEnabled = true;
			this->cbxBank6->Items->AddRange(gcnew cli::array< System::Object^  >(7) {L"[0] None", L"[1] \'PathLift\', Fish, \'StarGate\', Door, Chomp, \'Ibl\', Butterfly", 
				L"[2] (dummy)", L"[3] None", L"[4] None", L"[5] None", L"[6] None"});
			this->cbxBank6->Location = System::Drawing::Point(56, 185);
			this->cbxBank6->Name = L"cbxBank6";
			this->cbxBank6->Size = System::Drawing::Size(323, 21);
			this->cbxBank6->TabIndex = 9;
			// 
			// cbxBank5
			// 
			this->cbxBank5->DropDownStyle = System::Windows::Forms::ComboBoxStyle::DropDownList;
			this->cbxBank5->FormattingEnabled = true;
			this->cbxBank5->Items->AddRange(gcnew cli::array< System::Object^  >(7) {L"[0] None", L"[1] Owl", L"[2] Flame thrower, \'UdLift\', Seesaw", 
				L"[3] Tornado, Pokey", L"[4] (dummy)", L"[5] None", L"[6] None"});
			this->cbxBank5->Location = System::Drawing::Point(56, 158);
			this->cbxBank5->Name = L"cbxBank5";
			this->cbxBank5->Size = System::Drawing::Size(323, 21);
			this->cbxBank5->TabIndex = 8;
			// 
			// label3
			// 
			this->label3->AutoSize = true;
			this->label3->Location = System::Drawing::Point(6, 53);
			this->label3->Name = L"label3";
			this->label3->Size = System::Drawing::Size(44, 13);
			this->label3->TabIndex = 1;
			this->label3->Text = L"Bank 1:";
			// 
			// cbxBank4
			// 
			this->cbxBank4->DropDownStyle = System::Windows::Forms::ComboBoxStyle::DropDownList;
			this->cbxBank4->FormattingEnabled = true;
			this->cbxBank4->Items->AddRange(gcnew cli::array< System::Object^  >(7) {L"[0] None", L"[1] Key", L"[2] Shark, Cheep-Cheep, Manta Ray, \'Menbo\'", 
				L"[3] \'Hyuhyu\', Pole, Thwomp, \'SimpleLift\', \'LineLift\', \'RotateUpDownLift\'", L"[4] Tox Box", L"[5] None", L"[6] None"});
			this->cbxBank4->Location = System::Drawing::Point(56, 131);
			this->cbxBank4->Name = L"cbxBank4";
			this->cbxBank4->Size = System::Drawing::Size(323, 21);
			this->cbxBank4->TabIndex = 7;
			// 
			// cbxBank3
			// 
			this->cbxBank3->DropDownStyle = System::Windows::Forms::ComboBoxStyle::DropDownList;
			this->cbxBank3->FormattingEnabled = true;
			this->cbxBank3->Items->AddRange(gcnew cli::array< System::Object^  >(7) {L"[0] None", L"[1] \'Pakun\', Red Bob-Omb, Goomba", 
				L"[2] Wall sign, Lakitu Reporter, Bunny, Peach, Toad", L"[3] (dummy)", L"[4] (dummy)", L"[5] None", L"[6] None"});
			this->cbxBank3->Location = System::Drawing::Point(56, 104);
			this->cbxBank3->Name = L"cbxBank3";
			this->cbxBank3->Size = System::Drawing::Size(323, 21);
			this->cbxBank3->TabIndex = 5;
			// 
			// cbxBank2
			// 
			this->cbxBank2->DropDownStyle = System::Windows::Forms::ComboBoxStyle::DropDownList;
			this->cbxBank2->FormattingEnabled = true;
			this->cbxBank2->Items->AddRange(gcnew cli::array< System::Object^  >(7) {L"[0] None", L"[1] \'Popoi\', Spiny, Lakitu", L"[2] Bob-Omb King", 
				L"[3] WF wall piece, \'Killer\', Whomp", L"[4] Castle painting, Crazed Crate, \'Choropu\'", L"[5] \'IceBlock\', \'Gamaguchi\', Snowman, \'Huwa\'", 
				L"[6] (dummy)"});
			this->cbxBank2->Location = System::Drawing::Point(56, 77);
			this->cbxBank2->Name = L"cbxBank2";
			this->cbxBank2->Size = System::Drawing::Size(323, 21);
			this->cbxBank2->TabIndex = 4;
			// 
			// cbxBank1
			// 
			this->cbxBank1->DropDownStyle = System::Windows::Forms::ComboBoxStyle::DropDownList;
			this->cbxBank1->FormattingEnabled = true;
			this->cbxBank1->Items->AddRange(gcnew cli::array< System::Object^  >(7) {L"[0] None", L"[1] (dummy)", L"[2] \'Keronpa\', \'Propeller_Heyho\'", 
				L"[3] \'Casket\', \'Eyekun\', Spider", L"[4] Baby penguin, Snowman parts (CCM)", L"[5] Chief Chilly, \'EWB_Ice\'", L"[6] Goomboss"});
			this->cbxBank1->Location = System::Drawing::Point(56, 50);
			this->cbxBank1->Name = L"cbxBank1";
			this->cbxBank1->Size = System::Drawing::Size(323, 21);
			this->cbxBank1->TabIndex = 3;
			// 
			// cbxBank0
			// 
			this->cbxBank0->DropDownStyle = System::Windows::Forms::ComboBoxStyle::DropDownList;
			this->cbxBank0->FormattingEnabled = true;
			this->cbxBank0->Items->AddRange(gcnew cli::array< System::Object^  >(7) {L"[0] None", L"[1] Koopa race flag, Koopa, \'Jango\', \'Holhei\'", 
				L"[2] Big Boo\'s Haunt objects", L"[3] \'Obj_Shell\', \'Water_Ring\', \'Water_Hakidasi\', LLL objects, Bullies", L"[4] TTC objects, \'Dossy\', \'Basabasa\', \'Yurei_Mucho\'", 
				L"[5] \'Iwante\'", L"[6] (dummy)"});
			this->cbxBank0->Location = System::Drawing::Point(56, 23);
			this->cbxBank0->Name = L"cbxBank0";
			this->cbxBank0->Size = System::Drawing::Size(323, 21);
			this->cbxBank0->TabIndex = 2;
			// 
			// label2
			// 
			this->label2->AutoSize = true;
			this->label2->Location = System::Drawing::Point(6, 26);
			this->label2->Name = L"label2";
			this->label2->Size = System::Drawing::Size(44, 13);
			this->label2->TabIndex = 0;
			this->label2->Text = L"Bank 0:";
			// 
			// LevelSettingsForm
			// 
			this->AutoScaleDimensions = System::Drawing::SizeF(6, 13);
			this->AutoScaleMode = System::Windows::Forms::AutoScaleMode::Font;
			this->ClientSize = System::Drawing::Size(421, 341);
			this->Controls->Add(this->groupBox2);
			this->Controls->Add(this->groupBox1);
			this->Controls->Add(this->btnCancel);
			this->Controls->Add(this->btnOk);
			this->FormBorderStyle = System::Windows::Forms::FormBorderStyle::FixedDialog;
			this->MaximizeBox = false;
			this->Name = L"LevelSettingsForm";
			this->Text = L"Level settings";
			this->FormClosed += gcnew System::Windows::Forms::FormClosedEventHandler(this, &LevelSettingsForm::LevelSettingsForm_FormClosed);
			this->groupBox1->ResumeLayout(false);
			this->groupBox1->PerformLayout();
			this->groupBox2->ResumeLayout(false);
			this->groupBox2->PerformLayout();
			this->ResumeLayout(false);

		}
#pragma endregion

		private: CLevelSettings^ m_LevelSettings;
				 Byte m_PrevBackground;

	private: System::Void btnOk_Click(System::Object^  sender, System::EventArgs^  e) 
			 {
				 m_LevelSettings->Background = cbxSkySetting->SelectedIndex;
				 m_LevelSettings->ObjBanks[0] = cbxBank0->SelectedIndex;
				 m_LevelSettings->ObjBanks[1] = cbxBank1->SelectedIndex;
				 m_LevelSettings->ObjBanks[2] = cbxBank2->SelectedIndex;
				 m_LevelSettings->ObjBanks[3] = cbxBank3->SelectedIndex;
				 m_LevelSettings->ObjBanks[4] = cbxBank4->SelectedIndex;
				 m_LevelSettings->ObjBanks[5] = cbxBank5->SelectedIndex;
				 m_LevelSettings->ObjBanks[6] = cbxBank6->SelectedIndex;

				 m_PrevBackground = m_LevelSettings->Background;

				 this->Close();
			 }
private: System::Void cbxSkySetting_SelectedIndexChanged(System::Object^  sender, System::EventArgs^  e) 
		 {
			 m_LevelSettings->Background = cbxSkySetting->SelectedIndex;

			 if (Owner)
				 Owner->Refresh();
		 }
private: System::Void LevelSettingsForm_FormClosed(System::Object^  sender, System::Windows::Forms::FormClosedEventArgs^  e) 
		 {
			 m_LevelSettings->Background = m_PrevBackground;

			 if (Owner)
				 Owner->Refresh();
		 }
};
}
