#pragma once

using namespace System;
using namespace System::ComponentModel;
using namespace System::Collections;
using namespace System::Windows::Forms;
using namespace System::Data;
using namespace System::Drawing;
using namespace System::Globalization;

#include "NitroROM.h"
#include "NitroOverlay.h"
#include "levelclasses.h"


namespace sm64ds_editor {

	/// <summary>
	/// Description rsume de ObjEditForm
	///
	/// AVERTISSEMENT: si vous modifiez le nom de cette classe, vous devrez modifier la
	///          proprit 'Nom du fichier de ressources' de l'outil de compilation de ressource manage
	///          pour tous les fichiers .resx dont dpend cette classe. Dans le cas contraire,
	///          les concepteurs ne pourront pas interagir correctement avec les ressources
	///          localises associes  ce formulaire.
	/// </summary>
	public ref class ObjEditForm : public System::Windows::Forms::Form
	{
	public:
		ObjEditForm(int num, CStdObject^ obj)
		{
			InitializeComponent();

			m_Object = obj;

			this->Text = String::Format("Object #{0}", num);
			tbxObjectID->Text = String::Format("{0:X4}", obj->ObjectID);
			tbxXPos->Text = String::Format("{0}", (float)(obj->XPos/4096.f));
			tbxYPos->Text = String::Format("{0}", (float)(obj->YPos/4096.f));
			tbxZPos->Text = String::Format("{0}", (float)(obj->ZPos/4096.f));
			tbxXRot->Text = String::Format("{0}", (float)(obj->XRot/4096.f));
			tbxYRot->Text = String::Format("{0}", (float)(obj->YRot/4096.f));
			tbxZRot->Text = String::Format("{0}", (float)(obj->ZRot/4096.f));
			tbxObjData->Text = String::Format("{0:X4}", obj->ObjectData);
		}

	protected:
		/// <summary>
		/// Nettoyage des ressources utilises.
		/// </summary>
		~ObjEditForm()
		{
			if (components)
			{
				delete components;
			}
		}
	private: System::Windows::Forms::Label^  label1;
	protected: 
	private: System::Windows::Forms::TextBox^  tbxObjectID;
	private: System::Windows::Forms::Label^  label2;
	private: System::Windows::Forms::Label^  label3;
	private: System::Windows::Forms::Label^  label4;
	private: System::Windows::Forms::Label^  label5;
	private: System::Windows::Forms::Label^  label6;
	private: System::Windows::Forms::Label^  label7;
	private: System::Windows::Forms::Label^  label8;
	private: System::Windows::Forms::TextBox^  tbxXPos;
	private: System::Windows::Forms::TextBox^  tbxYPos;
	private: System::Windows::Forms::TextBox^  tbxZPos;
	private: System::Windows::Forms::TextBox^  tbxXRot;
	private: System::Windows::Forms::TextBox^  tbxYRot;
	private: System::Windows::Forms::TextBox^  tbxZRot;
	private: System::Windows::Forms::TextBox^  tbxObjData;
	private: System::Windows::Forms::Button^  btnOk;
	private: System::Windows::Forms::Button^  btnCancel;


	protected: 


	private:
		/// <summary>
		/// Variable ncessaire au concepteur.
		/// </summary>
		System::ComponentModel::Container ^components;

#pragma region Windows Form Designer generated code
		/// <summary>
		/// Mthode requise pour la prise en charge du concepteur - ne modifiez pas
		/// le contenu de cette mthode avec l'diteur de code.
		/// </summary>
		void InitializeComponent(void)
		{
			this->label1 = (gcnew System::Windows::Forms::Label());
			this->tbxObjectID = (gcnew System::Windows::Forms::TextBox());
			this->label2 = (gcnew System::Windows::Forms::Label());
			this->label3 = (gcnew System::Windows::Forms::Label());
			this->label4 = (gcnew System::Windows::Forms::Label());
			this->label5 = (gcnew System::Windows::Forms::Label());
			this->label6 = (gcnew System::Windows::Forms::Label());
			this->label7 = (gcnew System::Windows::Forms::Label());
			this->label8 = (gcnew System::Windows::Forms::Label());
			this->tbxXPos = (gcnew System::Windows::Forms::TextBox());
			this->tbxYPos = (gcnew System::Windows::Forms::TextBox());
			this->tbxZPos = (gcnew System::Windows::Forms::TextBox());
			this->tbxXRot = (gcnew System::Windows::Forms::TextBox());
			this->tbxYRot = (gcnew System::Windows::Forms::TextBox());
			this->tbxZRot = (gcnew System::Windows::Forms::TextBox());
			this->tbxObjData = (gcnew System::Windows::Forms::TextBox());
			this->btnOk = (gcnew System::Windows::Forms::Button());
			this->btnCancel = (gcnew System::Windows::Forms::Button());
			this->SuspendLayout();
			// 
			// label1
			// 
			this->label1->AutoSize = true;
			this->label1->Location = System::Drawing::Point(12, 9);
			this->label1->Name = L"label1";
			this->label1->Size = System::Drawing::Size(81, 13);
			this->label1->TabIndex = 0;
			this->label1->Text = L"Object ID (hex):";
			// 
			// tbxObjectID
			// 
			this->tbxObjectID->Location = System::Drawing::Point(119, 6);
			this->tbxObjectID->MaxLength = 4;
			this->tbxObjectID->Name = L"tbxObjectID";
			this->tbxObjectID->Size = System::Drawing::Size(130, 20);
			this->tbxObjectID->TabIndex = 1;
			// 
			// label2
			// 
			this->label2->AutoSize = true;
			this->label2->Location = System::Drawing::Point(12, 35);
			this->label2->Name = L"label2";
			this->label2->Size = System::Drawing::Size(56, 13);
			this->label2->TabIndex = 2;
			this->label2->Text = L"X position:";
			// 
			// label3
			// 
			this->label3->AutoSize = true;
			this->label3->Location = System::Drawing::Point(12, 61);
			this->label3->Name = L"label3";
			this->label3->Size = System::Drawing::Size(56, 13);
			this->label3->TabIndex = 3;
			this->label3->Text = L"Y position:";
			// 
			// label4
			// 
			this->label4->AutoSize = true;
			this->label4->Location = System::Drawing::Point(11, 87);
			this->label4->Name = L"label4";
			this->label4->Size = System::Drawing::Size(56, 13);
			this->label4->TabIndex = 4;
			this->label4->Text = L"Z position:";
			// 
			// label5
			// 
			this->label5->AutoSize = true;
			this->label5->Location = System::Drawing::Point(12, 113);
			this->label5->Name = L"label5";
			this->label5->Size = System::Drawing::Size(55, 13);
			this->label5->TabIndex = 5;
			this->label5->Text = L"X rotation:";
			// 
			// label6
			// 
			this->label6->AutoSize = true;
			this->label6->Location = System::Drawing::Point(12, 139);
			this->label6->Name = L"label6";
			this->label6->Size = System::Drawing::Size(55, 13);
			this->label6->TabIndex = 6;
			this->label6->Text = L"Y rotation:";
			// 
			// label7
			// 
			this->label7->AutoSize = true;
			this->label7->Location = System::Drawing::Point(12, 165);
			this->label7->Name = L"label7";
			this->label7->Size = System::Drawing::Size(55, 13);
			this->label7->TabIndex = 7;
			this->label7->Text = L"Z rotation:";
			// 
			// label8
			// 
			this->label8->AutoSize = true;
			this->label8->Location = System::Drawing::Point(12, 191);
			this->label8->Name = L"label8";
			this->label8->Size = System::Drawing::Size(91, 13);
			this->label8->TabIndex = 8;
			this->label8->Text = L"Object data (hex):";
			// 
			// tbxXPos
			// 
			this->tbxXPos->Location = System::Drawing::Point(119, 32);
			this->tbxXPos->Name = L"tbxXPos";
			this->tbxXPos->Size = System::Drawing::Size(130, 20);
			this->tbxXPos->TabIndex = 9;
			// 
			// tbxYPos
			// 
			this->tbxYPos->Location = System::Drawing::Point(119, 58);
			this->tbxYPos->Name = L"tbxYPos";
			this->tbxYPos->Size = System::Drawing::Size(130, 20);
			this->tbxYPos->TabIndex = 10;
			// 
			// tbxZPos
			// 
			this->tbxZPos->Location = System::Drawing::Point(119, 84);
			this->tbxZPos->Name = L"tbxZPos";
			this->tbxZPos->Size = System::Drawing::Size(130, 20);
			this->tbxZPos->TabIndex = 11;
			// 
			// tbxXRot
			// 
			this->tbxXRot->Location = System::Drawing::Point(119, 110);
			this->tbxXRot->Name = L"tbxXRot";
			this->tbxXRot->Size = System::Drawing::Size(130, 20);
			this->tbxXRot->TabIndex = 12;
			// 
			// tbxYRot
			// 
			this->tbxYRot->Location = System::Drawing::Point(119, 136);
			this->tbxYRot->Name = L"tbxYRot";
			this->tbxYRot->Size = System::Drawing::Size(130, 20);
			this->tbxYRot->TabIndex = 13;
			// 
			// tbxZRot
			// 
			this->tbxZRot->Location = System::Drawing::Point(119, 162);
			this->tbxZRot->Name = L"tbxZRot";
			this->tbxZRot->Size = System::Drawing::Size(130, 20);
			this->tbxZRot->TabIndex = 14;
			// 
			// tbxObjData
			// 
			this->tbxObjData->Location = System::Drawing::Point(119, 188);
			this->tbxObjData->MaxLength = 4;
			this->tbxObjData->Name = L"tbxObjData";
			this->tbxObjData->Size = System::Drawing::Size(130, 20);
			this->tbxObjData->TabIndex = 15;
			// 
			// btnOk
			// 
			this->btnOk->Location = System::Drawing::Point(174, 225);
			this->btnOk->Name = L"btnOk";
			this->btnOk->Size = System::Drawing::Size(75, 23);
			this->btnOk->TabIndex = 16;
			this->btnOk->Text = L"Ok";
			this->btnOk->UseVisualStyleBackColor = true;
			this->btnOk->Click += gcnew System::EventHandler(this, &ObjEditForm::btnOk_Click);
			// 
			// btnCancel
			// 
			this->btnCancel->DialogResult = System::Windows::Forms::DialogResult::Cancel;
			this->btnCancel->Location = System::Drawing::Point(93, 225);
			this->btnCancel->Name = L"btnCancel";
			this->btnCancel->Size = System::Drawing::Size(75, 23);
			this->btnCancel->TabIndex = 17;
			this->btnCancel->Text = L"Cancel";
			this->btnCancel->UseVisualStyleBackColor = true;
			// 
			// ObjEditForm
			// 
			this->AutoScaleDimensions = System::Drawing::SizeF(6, 13);
			this->AutoScaleMode = System::Windows::Forms::AutoScaleMode::Font;
			this->ClientSize = System::Drawing::Size(261, 260);
			this->Controls->Add(this->btnCancel);
			this->Controls->Add(this->btnOk);
			this->Controls->Add(this->tbxObjData);
			this->Controls->Add(this->tbxZRot);
			this->Controls->Add(this->tbxYRot);
			this->Controls->Add(this->tbxXRot);
			this->Controls->Add(this->tbxZPos);
			this->Controls->Add(this->tbxYPos);
			this->Controls->Add(this->tbxXPos);
			this->Controls->Add(this->label8);
			this->Controls->Add(this->label7);
			this->Controls->Add(this->label6);
			this->Controls->Add(this->label5);
			this->Controls->Add(this->label4);
			this->Controls->Add(this->label3);
			this->Controls->Add(this->label2);
			this->Controls->Add(this->tbxObjectID);
			this->Controls->Add(this->label1);
			this->FormBorderStyle = System::Windows::Forms::FormBorderStyle::FixedDialog;
			this->MaximizeBox = false;
			this->Name = L"ObjEditForm";
			this->Text = L"ObjEditForm";
			this->ResumeLayout(false);
			this->PerformLayout();

		}
#pragma endregion

		CStdObjectEntry^ m_Object;

private: System::Void btnOk_Click(System::Object^  sender, System::EventArgs^  e)
		 {
			 UInt16 objid;
			 float xpos, ypos, zpos;
			 float xrot, yrot, zrot;
			 UInt16 objdata;

			 String^ bad = "";
			 if (!UInt16::TryParse(tbxObjectID->Text, NumberStyles::HexNumber, nullptr, objid)) bad = "object ID";
			 if (!float::TryParse(tbxXPos->Text, NumberStyles::Float, nullptr, xpos)) bad = "X position";
			 if (!float::TryParse(tbxYPos->Text, NumberStyles::Float, nullptr, ypos)) bad = "Y position";
			 if (!float::TryParse(tbxZPos->Text, NumberStyles::Float, nullptr, zpos)) bad = "Z position";
			 if (!float::TryParse(tbxXRot->Text, NumberStyles::Float, nullptr, xrot)) bad = "X rotation";
			 if (!float::TryParse(tbxYRot->Text, NumberStyles::Float, nullptr, yrot)) bad = "Y rotation";
			 if (!float::TryParse(tbxZRot->Text, NumberStyles::Float, nullptr, zrot)) bad = "Z rotation";
			 if (!UInt16::TryParse(tbxObjData->Text, NumberStyles::HexNumber, nullptr, objdata)) bad = "object data";

			 if (bad != "")
			 {
				 MessageBox::Show(	String::Format("Invalid {0} value entered.\n\nPlease fix that.", bad),
									"Error",
									MessageBoxButtons::OK,
									MessageBoxIcon::Error);
				 return;
			 }

			 bad = "";
			 if ((xpos < -8.f) || (xpos > 8.f)) bad = "X position";
			 if ((ypos < -8.f) || (ypos > 8.f)) bad = "Y position";
			 if ((zpos < -8.f) || (zpos > 8.f)) bad = "Z position";
			 if ((xrot < -8.f) || (xrot > 8.f)) bad = "X rotation";
			 if ((yrot < -8.f) || (yrot > 8.f)) bad = "Y rotation";
			 if ((zrot < -8.f) || (zrot > 8.f)) bad = "Z rotation";

			 if (bad != "")
			 {
				 MessageBox::Show(	String::Format("The {0} value entered is out of range.\nIt should be comprised between -8 and 8.\n\nPlease fix that.", bad),
									"Error",
									MessageBoxButtons::OK,
									MessageBoxIcon::Error);
				 return;
			 }

			 m_Object->ObjectID = objid;
			 m_Object->XPos = (Int16)((xpos == 8.f) ? 0x7FFF : (xpos * 4096));
			 m_Object->YPos = (Int16)((ypos == 8.f) ? 0x7FFF : (ypos * 4096));
			 m_Object->ZPos = (Int16)((zpos == 8.f) ? 0x7FFF : (zpos * 4096));
			 m_Object->XRot = (Int16)((xrot == 8.f) ? 0x7FFF : (xrot * 4096));
			 m_Object->YRot = (Int16)((yrot == 8.f) ? 0x7FFF : (yrot * 4096));
			 m_Object->ZRot = (Int16)((zrot == 8.f) ? 0x7FFF : (zrot * 4096));
			 m_Object->ObjectData = objdata;

			 this->Close();
		 }
};
}
